<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################
# 

/**
 *	
 *	
 *	@author		Jan Hnatek
 *	@package	admin
 */
class section {
//-----------//

	// VARIABLES
	//
	
	/**	Parent module object to derive rights from. */
	var $module;
	
	/**	File to include with this menu_item. */
	var $include_file;
	
	/** Minimal right to display this item. */
	var $right;
	
	/** Bool to leave the put out form opened. */
	var $open_form;
	
	/**	Array of menu_button objects. */
	var $buttons;


	// CONSTRUCTOR
	//
	
	/**	Set up 
	 */
	function section (&$module, $filename, $open_form, $buttons) {
		global $section;
		$this->module =& $module;
		$this->include_file = $filename;
		$this->open_form = $open_form;
		$this->right = $this->module->get_right ($section);
		$this->buttons = $buttons;
	}


	// METHODS
	//
	
	/**	Return array of buttons for this section.
	 *	Access rights check is performed before returning the value.
	 */
	function get_buttons () {
		global $user;
		//debug ("section->get_buttons()");
		// save original size for use in for: unseting values changes count() results
		$origsize = count ($this->buttons);
		for ($i=0; $i < $origsize; $i++) {
			$tmp =& $this->buttons[$i];
			//debug ("index: $i"); adebug ($tmp);
			conderror (isset ($tmp->right), "access right not specified for ". q($tmp->label));
			if (!$user->check_my ($tmp->right))
				unset ($this->buttons[$i]);
		}
		return $user->check_my ($this->right) ? array_values ($this->buttons) : false;
	}

	/**	Return access right according to ini.
	 *	If not set in ini, use the right of this object.
	 *	That makes it a tree structure of rights, where leaves have highest priority.
	 */
	function get_right ($path) {
		global $section;
		$path = "$section:$path";
		//debug ("section->get_right(:$path)");
		return $this->module->isset_right ($path) ? $this->module->get_right ("$path") : $this->right;
	}
	
	/**	Tells whether given value of right is set in ini. */
	function isset_right ($path) {
		global $section;
		//debug ("section->isset_right(:$section:$path)");
		return $this->module->isset_right ("$section:$path");
	}
	
}	// class section

?>
