<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

define ("ISSUE_CURRENT", 1);
define ("ISSUE_ARCHIVED", 2);
define ("ISSUE_VISIBLE", 3);
define ("GROUP_VISIBLE", 4);
define ("VISIBLE", 7);
define ("INVISIBLE", 0);


/**
 *	Client part support for Article System.<br>
 *	A set of database querying methods for getting client part data
 *	from the Article System database.
 *
 *	@author	Jan Hnatek
 *	@package client
 */
class client {

    // VARIABLES
    //
	// private
	var $a_articles;
	var $a_agroups;
	var $a_issues;
	var $a_volumes;
	var $a_images;
	var $a_users;
	
	var $error;

	// public
	var $articles;
	var $agroups;
	var $issues;
	var $volumes;
	var $images;
	var $users;

	//var $active_issue;
	//var $active_article;
	var $article;


	// CONSTRUCTOR
	//
	/**	Contructor of client class.<br>
	 *	@access	public
	 */
	function client (&$art, &$gro, &$iss, &$ima, &$use, $actiss='') {
		global $db;
		if (!is_object ($db))
			return false;
		// fill privates
    	$this->a_articles = $art;
        $this->a_agroups = $gro;
        $this->a_issues = $iss;
		$this->a_volumes = new db_entity ("Volumes");
		$this->a_images = $ima;
		$this->a_users = $use;
		// create publics (client objects)
		$this->articles =& new client_articles ($art, $ima);
		$this->issues =& new client_issues ($art, $iss, $ima);
		$this->volumes =& new client_volumes ($iss, $this->a_volumes);
		$this->agroups =& new client_groups ($art, $gro, $ima);
		$this->users =& new client_users ($art, $use, $ima);

        //if (is_numeric ($actiss))
		//	$this->active_issue = $actiss;
    	$this->connect ();
	}


// COMMON METHODS
//
	/**	Connect to the database.
	 *	@access	public
	 *	@return	boolean
	 */
	function connect () {
		// FIXME: TOGGLE persistent off, disable old way of opening db
		global $db;
		$db->open (0);
	}

// WRAPPERS (DEPRECATED, UNFINISHED)
//
/*
	function get_issue ($id=0, $flags=VISIBLE)
		{ return $this->issues->get ($id, $flags); }
	function get_issue_archive ($b='')
		{ return $this->issues->get_archive ($b); }
	function get_issue_menu ($id, $menu_group=true)
		{ return $this->issues->get_menu ($id, $menu_group); }
	function get_issue_image_tag ($id, $bonus='')
		{ return $this->issues->get_image_tag ($id, $bonus); }
	function get_issue_articles ($id)
		{ return $this->issues->get_articles ($id); }
	function get_article_image_tag ($id, $bonus='')
		{ return $this->articles->get_image_tag ($id, $bonus); }

*/


// OBSOLETE / DEPRECATED ?
// TEMPORARY / TESTING METHODS
// TODO:
	/**	Get an issue to display with respect to fake issue input.
	 *	@return asoc.array $issue ('id', 'name', ..)
	 * /
	// TODO: check active session in db ??? .. fake issue login should be authenticated ???
	// TODO: fake issues : check referrer !!! ??? how ???
	// TODO: set different user_id for admin ???
	function test_fake_issue (&$user, $fake_active_issue, $fake) {
		// we don't want both to be set
		if (isset ($fake_active_issue))
			unset ($fake);
		if (isset ($fake)) {
			// we got fake issue id from previous session
			$issue['id'] = $fake;
			debug ("fake: ". $issue['id']);
		} else {
			// we have to set $fake, if $fake_active_issue is set
			if (isset ($fake_active_issue)) {
				// check rights for issue management
				if ($user->check_my ("a_publish")) {
					$issue['id'] = $fake_active_issue;
					$fake = $issue['id'];
					debug ("fake: ".$issue['id']);
				} else
					$issue = $this->get_current_issue ();
			} else
				$issue = $this->get_current_issue ();
		}
		return $issue;
	} // test_fake_issue()


	/**	An example of article rendering function.
	 *	@param	$article	Id of an article to display.
	 * /
	// TODO: should be probably rendered with help of $gui
	function display_article ($article) {
		if (is_numeric ($article)) {
			// TODO: test if in current issue
			$this->get_article ($article);	?>
		<table width="500" align="center" border="0" cellpadding="0" cellspacing="0">
		<!-- article title -->
		<tr><td bgcolor="#808080" align="center">
<?			echo "<b>". $this->get_adata ('title') ."</b>\n"; ?>
		</td></tr>
		<!-- article subtitle -->
		<tr><td>
		<br>
<?			echo "<p>". $this->get_formatted ('subtitle') ."</p>\n"; ?>
		</td></tr>
		<tr><td>
		<br>
		<!-- article content -->
<?			echo "<p>". $this->get_adata ('content') ."</p>\n"; ?>
		<br>
		</td></tr>
		<!-- author signature -->
		<tr><td bgcolor="#c0c0c0" align="right">
<?			echo "<p>". $this->get_formatted ('signature') ."</p>\n"; ?>
		</td></tr>
		</table>
<?		}
	} // display_article()
*/

} // class
