<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

/**
 *	Client part support for Article System.<br>
 *	Functions to handle volumes on the client side.
 *
 *	@author	Jan Hnatek
 *	@package client
 */
class client_users extends client_entity {

    // VARIABLES
    //
	var $a_articles;
	var $a_users;
	var $a_images;

	var $error;

	// CONSTRUCTOR
	//
	function client_users (&$art, &$use, &$ima) {
		global $db;
		if (!is_object ($db))
			return false;
		$this->a_articles = $art;
		$this->a_users = $use;
		$this->a_imagess = $ima;
	}			

	// USER METHODS
	//
	/**	Return user data.
	 *	@param	$id	User id.
	 *	@param	$bonus	String, that is appended to the query. Possibly for ORDER BY, ...
	 *	@return associative array
	 * /
	function get ($id, $bonus='') {
		return $this->a_users->get_one ('*', "WHERE id='$id' ". $bonus);
	}

	/**	Returns all users in db.
	 *	Namely 'id, name' for each of them.
	 *	@return associative array
	 * /
	function get_all ($bonus='') {
		// TODO: order by ??
		$vols = $this->a_issues->get ("volume", "WHERE archived='1' or current='1' GROUP BY volume $bonus");
		$vlist = '';
		foreach ($vols as $v)
			$vlist .= $v['volume'] .",";
		perl_chop ($vlist);
		return $this->a_volumes->get ("id, name", "WHERE id IN ($vlist)");
	}
	*/
	/**	Return data of users that are authors of published articles.
	 *	The result is sorted by user name by default.
	 *	Note: That doesn't mean it returns users from group 'authors',
	 *	those are two different things.
	 *	@returns array
	 *	@access	public
	 */
	function get_publishing ($what="U.id,U.name") {
		global $db;
		$this->result = array ();
		// FIXME: this does not limit to published issues strictly ??
		$RS = $db->exec ("SELECT DISTINCT $what FROM Users U LEFT JOIN Articles A
			ON (U.id=A.author) WHERE A.issue IS NOT NULL
			ORDER BY name");
		if (!$RS) {
			$this->error = $db->report (msg ("select fail"));
			return false;
		}
		while ($row = $db->get_result_array ())
			array_push ($this->result, $row);
		return $this->result;
	}

	/**	Returns basic data of articles by given user.
	 *	Namely 'id, title, subtitle, menu_title, menu_group'.
	 *	The list is ordered by 'iorder'.
	 *	@param	$id	Id of an user
	 *	@return array of associative arrays
	 */
	function get_articles ($id) {
		return $this->a_articles->get_by_user ($id, 
			"A.id, A.title, A.subtitle, A.preview, A.menu_title, A.menu_group",
			"AND (I.archived = '1' OR I.current = '1')");
	}

} // class client_users
