<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

/**
 *	Client part support for Article System.<br>
 *	Functions to handle volumes on the client side.
 *
 *	@author	Jan Hnatek
 *	@package client
 */
class client_volumes extends client_entity {

    // VARIABLES
    //
	var $a_issues;
	var $a_volumes;

	
	// CONSTRUCTOR
	//
	function client_volumes (&$iss, &$vol) {
		global $db;
		if (!is_object ($db))
			return false;
		$this->a_issues = $iss;
		$this->a_volumes = $vol;
	}

	// VOLUME METHODS
	//
	/**	Return volume data.
	 *	@param	$id	Volume id.
	 *	@param	$bonus	String, that is appended to the query. Possibly for ORDER BY, ...
	 *	@return associative array
	 */
	function get ($id, $bonus='') {
		return $this->a_volumes->get_one ('*', "WHERE id='$id' ". $bonus);
	}

	/**	Returns all volumes in db.
	 *	Namely 'id, name' for each of them.
	 *	@return associative array
	 */
	function get_all ($bonus='') {
		$vols = $this->a_issues->get ("volume", "WHERE archived='1' or current='1' GROUP BY volume");
		$vlist = '';
		foreach ($vols as $v)
			if ($v['volume'])
				$vlist .= $v['volume'] .",";
			else
				warning ("volume set to NULL !");
		perl_chop ($vlist);
		return $this->a_volumes->get ("id, name", "WHERE id IN ($vlist) $bonus");
	}

	/**	Returns data on issues from given volume.
	 *	@param	$id		Volume id.
	 *	@param	$bonus	String, that is appended to the query. Possibly for ORDER BY, ...
	 *	@return associative array
	 */
	function get_issues ($id, $bonus='') {
		return $this->a_issues->get ('id, name, menu_title, subtitle, published_on', "WHERE volume='$id' ". $bonus);
	}

} // class client_volumes
