<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

/**	
 *	Abstract class for Agroups entity in ArtSys DB.<br>
 *	Contains custom <code>SELECT</code> SQL queries.<br><br>
 *
 *	<b>Note: This is Article System specific class.</b>
 *
 *	@author	Jan Hnatek
 *	@package db_entities
 */
class db_agroups extends db_entity {
//--------------------------------//

	// CONSTRUCTOR
	//

	/**	Constructor of db_agroups class.<br>
	 *	@access	public
	 */
	function db_agroups () {
		db_entity::db_entity ("Agroups");
	}


	// METHODS
	//

	/**	Returns an associative array with data for agroup selector (id, parent, name).
	 *	@param	$assoc	array	An array to put values to.
	 *	@param	$where	string	Optional WHERE/ORDER clause.
	 *	@returns array
	 *	@access	public
	 */
	function get_select_data (&$assoc, $where="") {
		global $db;
		$this->result = $db->array_exec ("SELECT A.id as id, G.name as parent, A.name as name
			FROM Agroups A LEFT JOIN Agroups G ON A.parent=G.id $where ORDER BY A.parent, A.name");
		if (!$this->result)
			return false;
		reset ($this->result);
		foreach ($this->result as $row)
			$assoc[$row["id"]] = $row['name'] ." (". $row['parent']. ")";
		return $assoc;
	}

}	// class db_agroups

?>
