<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

/**	
 *	Abstract class for Articles entity in ArtSys DB.<br>
 *	Contains custom <code>SELECT</code> SQL queries.<br><br>
 *
 *	<b>Note: This is Article System specific class.</b>
 *
 *	@author	Jan Hnatek
 *	@package db_entities
 */
class db_users extends db_entity {
//------------------------------//

	// CONSTRUCTOR
	//

	/**	Constructor of db_users class.<br>
	 *	@access	public
	 */
	function db_users () {
		db_entity::db_entity ("Users");
	}


	// METHODS
	//

	/**	Returns the name of a user given by id.
	 *	@param	$id	int	The 'id' value of a user.
	 *	@access	public
	 *	@returns string
	 */
	function get_name ($id) {
		if (!$this->get_one ('name', "WHERE id='$id'"))
			return false;
		return $this->result [0]['name'];
	}

}	// class db_users

?>
