<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

/**
 *	Toolset for simple rendering of markup language tags.<br>
 *	An abstract parent class.
 *
 *	@author	Jan Hnatek
 *	@package layout
 */
class tag_writer {
//--------------//

	// CONSTRUCTOR
	//

	/** This is an abstract class, however, this constructor
	 *	can be used to create an instance of one of known subclasses.
	 *	@param	$subclass	One of ('plain', 'taset').
	 *	@access	public
	 */
	function tag_writer ($subclass='plain') {
		// TODO:
	}


	// METHODS
	//

	/**	Output unclosed (without '&gt;') opening tag.
	 *	@access	public
	 */
	function open () {
		// abstract
	}

	/**	Output opening tag(s). Add a newline.
	 *	Variable number of input variables accepted.
	 *	Input can be a string or an array.
	 *	Each string is handled as a tag name which is written to output.
	 *	First value of an array is handled the same, other values are
	 *	taken as parameters for subclasses.
	 *	@access	public
	 */
	function begin () {
		// abstract
	}

	/**	Output closing tag(s). Add a newline.
	 *	Variable number of input strings accepted. Each is handled
	 *	as a closing tag name which is written to output.
	 *	@access	public
	 */
	function end () {
		// abstract
	}

	/**	Output "full" tag, ie. opening tag, content and closing tag.
	 *	@param	$tag		Tag name.
	 *	@param	$content    Content to be copied to output.
	 *	@access	public
	 */
	function full ($tag, $content) {
		// abstract
	}

}	// class tag_writer

?>
