<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

//require_once 'class.tag_writer.php';


/**
 *	Toolset for simple rendering of markup language tags.<br>
 *	The simplest tag_writer - output "as is", with no attributes.<br>
 *	<br>
 *	Note: Ignores all tag parameters, that can be optionally passed
 *	in an array with <code>begin</code> and <code>full</code> methods.
 *
 *	@author	Jan Hnatek
 *	@package layout
 */
class tag_writer_plain extends tag_writer {
//---------------------------------------//

	/** [Overriden: See parent class for details.]
	 */
	function open ($tag) {
		echo is_array ($tag) ? "<$tag[0]" : "<$tag";
	}

	/** [Overriden: See parent class for details.]
	 */
	function begin () {
		foreach (func_get_args() as $tag)
			echo is_array ($tag) ? "<$tag[0]>" : "<$tag>";
		echo "\n";
	}

	/** [Overriden: See parent class for details.]
	 */
	function end () {
		foreach (func_get_args() as $tag)
			echo is_array ($tag) ? "</$tag[0]>" : "</$tag>";
		echo "\n";
	}

	/** [Overriden: See parent class for details.]
	 */
	function full ($tag, $content) {
		if (is_array ($tag))
			echo "\t<$tag[0]>$content</$tag[0]>\n";
		else
			echo "\t<$tag>$content</$tag>\n";
	}

}	// class tag_writer_plain

?>
