<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

//require_once 'class.tag_writer_plain.php';
//require_once 'class.taset.php';


/**
 *	Toolset for simple rendering of markup language tags.<br>
 *	Output is created using Tag Attribute Set (taset) class.
 *	All desired tag attributes are to be stored in an instance of
 *	<code>taset</code> class.
 *	<br>
 *	Note: Tag parameters are passed to <code>taset</code> as custom tag identifiers.
 *
 *	@see	taset
 *	@author	Jan Hnatek
 *	@package layout
 */
class tag_writer_taset extends tag_writer_plain {
//---------------------------------------------//

	/**	Pointer to a <code>taset</code> associated with this class.
	 */
	var $_taset;

   	
	// CONSTRUCTOR
	//

	/**	Associate a <code>taset</code> with this writer.
	 */
	function tag_writer_taset (&$taset) {
		$this->_taset = $taset;
	}


   	// METHODS : PUBLIC
	//

    /**	Associate a <code>taset</code> with this writer.
	 *	Given parameter is not checked, so first call for taset's expected methods
	 *	will fail, if a wrong one was given.
	 *	@param	$taset	An instance of <code>taset</code> class.
	 *	@access	public
	 */
	function set_taset (&$taset) {
		$this->_taset = $taset;
	}

	/**	Return <code>taset</code> associated to this writer.
	 *	@access	public
	 */
	function get_taset () {
		return $this->_taset;
	}

	/** [Overriden: See parent class for details.]
	 */
	function open ($tag) {
		if (is_array ($tag))
			echo "<$tag[0]". $this->_taset->get ($tag[1]) ." ";
		else
			echo "<$tag". $this->_taset->get ($tag) ." ";
	}

	/** [Overriden: See parent class for details.]
	 */
	function begin () {
		foreach (func_get_args() as $tag) {
			if (is_array ($tag))
				echo "<$tag[0]". $this->_taset->get ($tag[1]) .">";
			else
                echo "<$tag". $this->_taset->get ($tag) .">";
		}
		echo "\n";
	}

	/** [Overriden: See parent class for details.]
	 */
	function full ($tag, $content) {
		if (is_array ($tag)) {
			echo "<$tag[0]". $this->_taset->get ($tag[1]) .">$content</$tag[0]>\n";
		} else {
			echo "\t<$tag". $this->_taset->get ($tag) .">$content</$tag>\n";
		}

	}

}	// class tag_writer_taset

?>
