<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################


/**
 *	A tool to retrieve data from various sources.<br><br>
 *
 *	Data is not manipulated anyway, ie. you get the same data you assign.<br>
 *	Plain reference assignment of data is made.<br>
 *	Think of this class as an abstract class.
 *
 *	@author	Jan Hnatek
 *	@package lists
 */
class data_retriever {
//------------------//

	/**	Data container.
	 */
	var $_data;

	/**	Initialize data to an empty array
	 */
	function data_retriever () {
		$this->_data = array();
	}

	/**	Data retrieving function.
	 *	Simple <code>$data</code> reference assignment is performed in this class.
	 *	Take this as abstract. Override in subclasses.<br>
	 *	Returns false if something fails.
	 */
	function prepare (&$data) {
		$this->_data = $data;
	}

	/**	Return retrieved data formatted to a 2D non-associative array.
 	 *	@access	public
	 */
	function format_array_2D () {
		return $this->_data;
	}
	
	/**	Test whether data is empty.
	 *	@access	public
	 *	@returns boolean
	 */
	function is_empty () {
		return empty ($this->_data);
	}

}	// class data_retriever

?>
