<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################


/**
 *	A tool to retrieve data from various sources.<br><br>
 *
 *	Data is retrieved from a <code>db_images</code> object.<br>
 *	Database SELECT query is perfromed based on given parameters.<br><br>
 *
 *	<b>Note: This is Article System specific class.</b>
 *
 *	@author	Jan Hnatek
 *	@see	db_images
 *	@package lists
 */
class data_retriever_db_images extends data_retriever {
//---------------------------------------------------//

	/**	Image types. */
	var $_img_types = array (
		1 => "GIF", 2 => "JPG", 3 => "PNG",
		4 => "SWF", 5 => "PSD", 6 => "BMP"
	);


	/**	Retrieve database data using <code>db_images</code> object.<br>
	 *	Database SELECT query is performed based on given parameter.
	 *	Image data from database are passed as last parameter, which makes the
	 *	returned array multi-dimensional.
	 *	@param	$db_images	An reference to <code>d_images</code> object.
	 *	@param	$sql_restriction	Optional "WHERE" sql statement to limit image list.
	 *	@see	db_images
	 */
	function prepare (&$db_images, $sql_restriction) {
		if (!is_object ($db_images))
			return false;
		debug ("Browse images registered in db.");
		debug ("with restriction: '".$sql_restriction."'<br>\n");
		// prepare data
		$this->_data = array ();
		$dbdata = $db_images->get ("*", $sql_restriction);
		foreach ($dbdata as $image) {
			$id = $image['id'];
			$filename = $image['filename'];
			$img = $db_images->get_size_array ($id, $image['width'], $image['height'], $image['filetype']);
			$type = $img[2];
			$info = $img[0]."x".$img[1]."x".$this->_img_types[$type];
			array_push ($this->_data, array ($id, $filename, $info, $image));
		}
	}

}	// class data_retriever_db_images

?>
