<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

/**
 *	Article System mailing subsystem.
 *	Gets recipients' data from database.<br>
 *	PHP <code>mail()</code> wrapper with some added functionality.
 *
 *	@author	Jan Hnatek
 *	@package mailer
 */
class mailer_db extends mailer {
//----------------------------//

	// VARIABLES
	//
	var $db;
	var $system_email;

	// CONSTRUCTOR
	//
	function mailer_db ($email=NULL) {
		global $db;
		mailer::mailer ();
		$this->db =& $db;
		$this->system_email = $email;
		$this->set_From ($this->system_email);
		$this->set_ReplyTo ($this->system_email);
		$this->set_To ($this->system_email);
	}


	// PUBLIC METHODS
	//
	/**	Compile an issue notification mail message.<br>
	 *	@param	$id		Issue $id to notify about.
	 */
	function compile_issue_notification ($id) {
		global $issues, $articles, $config;
		$message = read_file ("{$config['admin_dir']}/templates/issue_notification.php");
		$new = $issues->get_one ('name', "WHERE id='$id'");
		foreach ($articles->get_issue ($id) as $a)
			$message .= "\t". $a['title'] ."\r\n";
		$message .= read_file ("{$config['admin_dir']}/templates/notification_footer.php");
		return $message;
	}

	/**	Compile an article notification mail message.
	 *	@param	$id		Article $id to notify about.
	 */
	function compile_article_notification ($id) {
		global $articles, $config;
		$message = read_file ("{$config['admin_dir']}/templates/article_notification.php", array ('config'));
//			array ("BASE_ADMIN_URL"));
		$new = $articles->get_one ("title", "WHERE id='$id'");
		$message .= "\t". $new["title"] ."\r\n";
		$message .= read_file ("{$config['admin_dir']}/templates/notification_footer.php", array ('config'));
//			array ("BASE_URL", "ADMIN_EMAIL"));
		adebug ($message);
		return $message;
	}
	
	/**	Prepare list of issue notification recipients.
	 */
	function prepare_recipients_issue () {
		global $users, $maillist;
		// prepare local recipients
		$rec_local = $users->get ('email', "WHERE notify_issues='1'");
		// prepare external recipients
		$rec_extern = $maillist->get ('email', "WHERE blocked='0'");
		$elist = "";
		foreach (array_merge ($rec_local, $rec_extern) as $tmp)
			$elist .= $tmp['email']. "\n";
		return $elist;
	}
	
	/**	Prepare list of article notification recipients.
	 */
	function prepare_recipients_article () {
		global $users;
		// prepare local recipients
		$rec_local = $users->get ('email', "WHERE notify_articles='1'");
		$elist = "";
		foreach ($rec_local as $tmp)
			$elist .= $tmp['email']. "\n";
		return $elist;
	}

	/**	Send notification (given message) to given list of recipients.
	 *	@param	$text	Message text.
	 *	@param	$recipients	Newline separated list of message recipients.
	 */
	function send_notification ($subject, $text, $recipients) {
		global $users, $mailto;
		$rec = preg_replace ("/\r?\n/", ', ', $recipients);
		$rec = chop ($rec, ', ');
		$this->set_Bcc ($rec);
		$this->send_blind ($text, $subject);
	}

} // class mailer_db

?>
