<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################
#


/**	
 *	A class to easily handle file uploads.<br>
 *	Subclassed <code>upload</code> rewritten to use <code>tag_writer</code>.
 *	
 *	@version	1.2, 24.1.2003
 *	@author		Jan Hnatek
 *	@package	upload
 */
class upload_tw extends upload
//--------------------------//
{

	// VARIABLES
	//

	/** Associated <code>tag_writer</code>. */
	var $_tw;


	// CONSTRUCTOR
	//

	/**	Set up associated tag writer. Call parent class constructor.
	 *	@param	$twriter	<code>tag_writer</code> instance reference.
	 */
    function upload_tw ($dir, &$twriter, $maxsize="0", $ierrors='') {
		upload::upload ($dir, $maxsize, $ierrors);
		$this->_tw = $twriter;
	}


	// OVERRIDES : PUBLIC METHODS
	//
		
	/**	Insert the script form with a table.
	 *	@param	$submit		name of the submit button
	 */
	function insert_form ($url, $submit="upload", $msg="send file", $table_attr="", $p_attr="") {
		$this->submit = $submit;
		echo "\n\n<!-- upload : table begin -->\n";
		echo "<form method=\"post\" enctype=\"multipart/form-data\" action=\"$url\">";
		if ($this->maxsize)
			echo "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"". ($this->maxsize * 1024) ."\">";
		$this->_tw->begin (array ("table", "table.img_code"), array ("tr", "tr.img_code"));
		// TODO: msg
		$this->_tw->full (array ("td", "td.img_code"), "Upload:");
		$this->_tw->begin (array ("td", "td.img_code"));
		$this->_tw->open (array ("input", "input.img_upload"));
		echo "\n type=\"file\" size=\"40\" name=\"$this->_filedef\">";
		$this->_tw->open (array ("input", "input.img_upload"));
		echo "\n type=\"submit\" name=\"$this->submit\" value=\"$msg\">";
		$this->_tw->end ("td", "tr", "table");
		echo "</form>";
		echo "\n\n<!-- upload : code table end -->\n";
	}


}	// class upload_tw

?>
