<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

/**	
 *	Richedit editor control object.
 *	
 *	@author	Jan Hnatek
 */
class richedit extends visual_ed {
//------------------------------//

	// METHODS
	//
	/** Recognize the browser, see if we can enable richtext editor.
	 *	Is called from constructor.
	 *	@access	private
	 *	@return	bool
	 */
	function check_browser () {
		if (preg_match ('/MSIE/i', $this->browser)) {
			if (preg_match ('/Mac/i', $this->browser))
				return false;
			// Opera 6.01 tested .. failed
			elseif (preg_match ('/Opera/i', $this->browser))
				return false;
			elseif (preg_match ('/Windows/i', $this->browser)) {
				$version = preg_replace ("/^.*MSIE ([0-9]\.[0-9]).*$/", "\\1", $this->browser);
				//debug ($version);
				return ($version >= 5.5) ? true : false;
    		}
		} elseif (preg_match('/Mozilla/i', $this->browser)) {
			if (preg_match ('/Mac/i', $this->browser))
				return false;
			elseif (preg_match ('/Windows/i', $this->browser))
				return false;
		}
		return false;
	}
	
	/**	Returns the code of the richedit link (which opens new window).
	 *	@param	$item	Name of the form item which' contents should be edited.
	 *	@param	$wname	Javascript name of the window to create.
	 *	@param	$text	Text of the link. Possibly may be an img tag.
	 *	@access	public
	 *	@return string (anchor tag)
	 */
	function get ($item, $wname, $text="") {
        if ($this->supported) {
            if ($text == "")
                $text = $this->default_text;
            return "<a href=\"#\" onClick=\"rw = window.open('rte/popup_editor.php?form=". $this->form ."&item=$item&msg=".
            urlencode (msg('editor submit')). "', '$wname', 'width=650, height=450, resizable=yes'); rw.focus();\">$text</a>";
        } else
            return false;
	}
	
} // class richedit

?>
