<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

/**	
 *	Abstract visual editor control object.
 *	
 *	@author	Jan Hnatek
 */
class visual_ed {
//-------------//

	// VARIABLES
	//
	var $browser;
	var $supported;
	var $form;
	var $default_text;
	var $error;

	// CONSTRUCTOR
	//
	/**	Visual_ed contructor.
	 *	Sets the form name and internal value <code>supported</code> based on current browser.
	 *	@param	$iform	Name of the form, whose items are we editing.
	 *	@param	$deftext	Default text of richedit links (useful, if it's an image).
	 *	@access	public
	 */
	function visual_ed ($iform, $deftext='') {
		$this->form = $iform;
		$this->default_text = $deftext;
		$this->browser = getenv ('HTTP_USER_AGENT');
		//debug ("<br>".$this->browser);
		$this->supported = $this->check_browser ();
	}

	// METHODS
	//
	/** Recognize the browser, see if we can enable richtext editor.
	 *	Is called from constructor.
	 *	@access	private
	 *	@return	bool
	 */
	function check_browser () {
		// abstract
	}
	
	/**	Place the visual_ed control tag in the document.
	 *	Echoes result of <code>get</code> method.
	 *	@param	$item	Name of the form item which' contents should be edited.
	 *	@param	$text	Text of the link. Possibly may be an img tag.
	 *	@access	public
	 *	@return void
	 */
	function place ($item, $wname, $text='') {
		if ($this->supported) {
			if ($text == '')
				$text = $this->default_text;
			echo $this->get ($item, $wname, $text);
		} else {
			$this->error = 'Your browser is not supported';
		}
	}
	
	/**	Returns the code of the visual_ed link (which opens new window).
	 *	@param	$item	Name of the form item which' contents should be edited.
	 *	@param	$wname	Javascript name of the window to create.
	 *	@param	$text	Text of the link. Possibly may be an img tag.
	 *	@access	public
	 *	@return string (anchor tag)
	 */
	function get ($item, $wname, $text='') {
		// abstract
	}
	
    /**	Prints formatted error message.
     *	Applications should call this function at a 'placeholder' that displays an error message if error occurs.
     *	@return void
     *	@access public
     */
	function error_report () {
		if (isset ($this->error)) {
			printf ('<br>%s', $this->error);
			return true;
		} else
			return false;
	}

} // class visual_ed

?>
