<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################
# MAIN DB OBJECT
#

	// include it
	require_once INCLUDE_DIR ."/classes/db/class.abstract_db.php";
	require_once INCLUDE_DIR ."/classes/db/class.mysql_db.php";
	require_once INCLUDE_DIR ."/classes/db/class.postgres_db.php";
	// and make an instance (DB_TYPE from config.php)
	switch ($config["db_type"]) {
	case "mysql":
		$db = new mysql_db ($config["db_name"], $config["db_host"],
			$config["db_user"], $config["db_pass"]);
		break;
  	case "postgres":
		$db = new postgres_db ($config["db_name"], $config["db_host"],
			$config["db_user"], $config["db_pass"]);
		break;
  	default:
		failexit ("Error in config.php: unknown database type!");
  	}


###############################################################################
# GLOBAL DATABASE objects
#

	require_once INCLUDE_DIR ."/classes/db_entities/class.db_entity.php";
	$issues = new db_entity ("Issues");
	$maillist = new db_entity ("Maillist");

	// some special objects
	//
	require_once INCLUDE_DIR ."/classes/db_entities/class.db_articles.php";
	$articles = new db_articles ();

	require_once INCLUDE_DIR ."/classes/db_entities/class.db_agroups.php";
	$agroups = new db_agroups ("Agroups");
	
	// TODO: i'd like this to be smaller, the only thing used is ->get_name () ???
	require_once INCLUDE_DIR ."/classes/db_entities/class.db_users.php";
	$users = new db_users ();

	// images object and settings
	//
	// image browser script (used with no target form item)
	require_once INCLUDE_DIR ."/classes/db_entities/class.db_images.php";
	$images = new db_images (
		$config["image_dir"], $config["image_url"],
		$config["upload_dir"], $config["upload_url"]
	);

?>
