<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

class form_articles_groups extends form_process {
//---------------------------------------------//

	var $ddata;
	var $input;
	var $list;

	function prepare () {
		global $user, $articles, $ASET_LIST;
		
		if (isset ($_POST['list']))		$list =& $_POST['list'];
		elseif (isset ($_GET['list']))	$list =& $_GET['list'];

		// get list of 'id's
		$this->list = $list;
		$art_ids = get_array_from ($list);
		debug ("list: ".$list);
		//debug ("total: ".count ($art_ids));
		//foreach ($art_ids as $aid) debug ("id: $aid");
		$ok = true;//test (count ($art_ids), alert_run (msg("not selected", "article")));
		if (!$ok)
			return false;

		// check rights
		/* NOTE: rights:
			a_create	.. everyone, who can create articles, can also select, in which groups !his articles! will be
						.. and more, he can do that only while his article is in author mode
			a_approve	.. can regroup others' articles (and must have a_create :-)
		 */
		$ok = test ($user->check_my ('a_create'), alert_run (msg('no rights')));
		echo msg('form With following articles');
		echo '<blockquote>';
		if (!$ok)
			return false;

		// get the articles into array
		$this->input = array ();
		$display_data = array ();
		foreach ($art_ids as $id) {
			$thisart = $articles->get_one ('id, author, title, menu_title, issue, author_done', "WHERE id='$id'");
			if ($thisart['menu_title'] == "")
				$thisart['menu_title'] = $thisart['title'];
			// allow only owned articles when I don't have a_approve
			if (!$user->check_my ("a_approve") && ($thisart['author'] != $user->id))
				//info (q ($thisart['title']) ."  ". msg("noown grouping"));
				array_push ($display_data, array ($thisart['title'], msg("noown grouping")));
			// allow only while in author mode
			elseif ( !$user->check_my ("a_approve") && $thisart['author_done'] == '1') {
				//info (q ($thisart['title']) ."  ". msg("finished grouping"));
				array_push ($display_data, array ($thisart['title'], msg("finished grouping")));
			} else {
				//info (q ($thisart['title']));
				array_push ($display_data, array ($thisart['title'], ''));
				array_push ($this->input, $thisart);
			}
		} // while
		// customize rendering
		$my_aset = $ASET_LIST;
		$my_aset->set ("td", array ('', ''));
		// prepare data
		$dr =& new data_retriever ();
		$dr->prepare ($display_data);
		// prepare tag writer
		$tw =& new tag_writer_taset ($my_aset);
		// create the list table using list_table class
		$table =& new list_table_limited ($dr->format_array_2D(), $tw);
		$table->use_header (array ("title", "symptoms"));
		$table->display ();
		echo "</blockquote>";

		// include the module, if we have some articles, that we can regroup
		if (count ($this->input)) {
			return true;
		} else {
			info (msg("no article left"));
			return false;
		}
	}

    function custom_check () {
		$this->_nonempty ("Action", msg("no action selected"));
		if ($this->values['Action'] != "LIST")
			if ($this->values['Group'] == "")
				$this->error ('Group', msg("no group selected"));
		if (!$this->values['Anum'])
			$this->error ('Anum', msg("no art left"));
	}

	function store_data () {
		global $db, $articles;
		$this->display_form ();
		// *** INSERT
		if ($this->values['Action'] == 'INS') {
			$this->ddata = array ();
			for ($i=0; $i < $this->values['Anum']; $i++)
				if (is_numeric ($this->values["Article$i"])) {
					$aid = $this->values["Article$i"];
					$gid = $this->values["Group"];
					$title = stripslashes ($this->values["Atitle$i"]);
					if ($articles->is_in_group ($aid, $gid)) {
						array_push ($this->ddata, array ($title, msg("article is in group")));
					} else {
						$db->exec ("INSERT INTO Ainsertion (article, agroup) VALUES ('$aid', '$gid')", 1);
						array_push ($this->ddata, array ($title, $db->report (msg("insert fail"), msg("saved")) ));
					}
			}
			$this->display_results (array ("title", "results"));

		// *** DELETE
		} elseif ($this->values['Action'] == 'DEL') {
			$this->ddata = array ();
			for ($i=0; $i < $this->values['Anum']; $i++)
				if (is_numeric ($this->values["Article$i"])) {
					$aid = $this->values["Article$i"];
					$gid = $this->values["Group"];
					$title = stripslashes ($this->values["Atitle$i"]);
					if ($articles->is_in_group ($aid, $gid)) {
						$db->exec ("DELETE FROM Ainsertion WHERE article='$aid' AND agroup='$gid'", 1);
						array_push ($this->ddata, array ($title, $db->report (msg("delete fail"), msg("removed")) ));
						//info ($db->report (msg("delete fail"), q($this->values["Atitle$i"]) .' &nbsp; '. msg("removed")));
					} else {
						array_push ($this->ddata, array ($title, msg("article not in group")));
						//info (q ($this->values["Atitle$i"]));
						//info ("&nbsp;&nbsp;".msg("article not in group"));
					}
			}
			$this->display_results (array ("title", "results"));

		// *** LIST
		} elseif ($this->values['Action'] == 'LIST') {
			$this->display_list ($this->values['Anum'], '$this->values["Article$i"]', '$this->values["Atitle$i"]');
		} else
			info (msg("internal action"));
	}

	/**	Data rendering function.
	 *	It's common for all actions. Renders results into table using list_table.
	 *	@param	$theader	Array of table header strings.
	 *	@see	list_table
	 *	@see	taset
	 */
	function display_results ($theader) {
		global $gui, $ASET_LIST;
		echo "<hr>";
		echo msg("form Results");
		echo "<blockquote>";
		$my_aset = $ASET_LIST;
		$my_aset->set ("td", array ('', ''));
		
		// prepare data
		$dr =& new data_retriever ();
		$dr->prepare ($this->ddata);
		// prepare tag writer
		$tw =& new tag_writer_taset ($my_aset);
		// create the list table using list_table class
		$table =& new list_table_limited ($dr->format_array_2D(), $tw);
		$table->use_header ($theader);
		$table->display ();
		echo "</blockquote>";
	}

	/**	List rendering function.
	 *	This is kinda hack.
	 *	It's used both with the new values (from $this->input) and the form values ($this->values[])
	 *	so I had to make the assignments as parameters .. that are eval()-ed.
	 *	@param	$acount	Number of articles.
	 *	@param	$id_eval	Right side of the evaluated assignment to article id.
	 *	@param	title_eval	Right side of the evaluated assignment to article title.
	 */
	function display_list ($acount, $id_eval, $title_eval) {
		global $db, $articles;
		debug ("display list: '$acount'");
		$this->ddata = array ();
		for ($i=0; $i < $acount; $i++) {
			eval ("\$aid = $id_eval;");
			if (is_numeric ($aid)) {
				$mygroups = $articles->get_all_groups ($aid);
				info ($db->report ($articles->get_error()));
				eval ("\$title = stripslashes ($title_eval);");
				$groups_line = "";
				foreach ($mygroups as $mygroup)
					$groups_line .= q ($mygroup['name']) . ", &nbsp;&nbsp;";
				array_push ($this->ddata, array ($title, $groups_line));
			}
   		}
		$this->display_results (array ("title", "groups"));
	}

    function display_form () {
		global $db, $agroups;
		$anum = count ($this->input);
		$t = new form_hidden ($this, "Anum", $anum);
		$t->display ();
		$this->error_report ('Anum');
		// deploy article ids
		for ($i=0; $i < $anum; $i++) {
			$t = new form_hidden ($this, "Article$i", $this->input[$i]['id']);
			$t->display ();
			$t = new form_hidden ($this, "Atitle$i", $this->input[$i]['title']);
			$t->display ();
		}
?>
		<input type="hidden" name="list" value="<?= $this->list ?>">
		<table>
			<?	// *** create action select box
				$options = array (
					"" => msg("pick action"),
					"INS" => msg("insert into"),
					"DEL" => msg("remove from"),
					"LIST" => msg("get groups")
				);
				$t = ($anum > 1) ?
					new form_select ($this, 'Action', $options, '') :
					new form_select ($this, 'Action', $options, 'LIST');
			?>
			<tr><td><?	$t->description ()	?></td>
				<td><?	$t->display ();
						$this->error_report ('Action');
				?></td>
			</tr>
			<?	// *** article group select box
				$gselect[""] = msg("pick group");
				$gselect = $agroups->get_select_data ($gselect);
				info ($db->report ($agroups->get_error (), ""));
				$t = new form_select ($this, 'Group', $gselect, "");
			?>
			<tr><td><?	$t->description ()	?></td>
				<td><?	$t->display ();
						$this->error_report ('Group');
				?></td>
			</tr>
		</table>
		</form>
<?		// display list if we have one article only
		// AND only if this is the first view of this page
		if ($anum == 1 && $this->first_time) {
   			$this->display_list ($anum, '$this->input[$i]["id"]', '$this->input[$i]["title"]');
  		}
	}

} // class

?>
