<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################
# list of articles : control part

$display = 0;

	// set up session vars
	if (!isset ($_SESSION['agroup']))
		$_SESSION['agroup'] = null;
	if (!isset ($_SESSION['aissue']))
		$_SESSION['aissue'] = null;
		
	// test if we have group/issue to list
	$group =& $_GET['group'];
	$issue =& $_GET['issue'];
	$agroup =& $_SESSION['agroup'];
	$aissue =& $_SESSION['aissue'];
	if ($group)	{	$agroup = $group;	unset ($aissue);	}
	if ($issue) {	$aissue = $issue;	unset ($agroup);	}
	if (!empty ($agroup) && is_scalar ($agroup)) {	$display++; unset ($aissue, $_SESSION['aissue']);	}
	if (!empty ($aissue) && is_scalar ($aissue)) {	$display++;	unset ($agroup, $_SESSION['agroup']);	}
	//debug ("agroup: $agroup");
	//debug ("aissue: $aissue");
	// set to default if not set at all
	if (empty ($agroup) && empty ($aissue)) {
		if ($config["list_display"] == "ALL") {
			$agroup = "all";
			$display++;
		}
	}

	// *** limits : group limit selector
	//
?>
	<form method="post" name="limits" action="main.php">
	<div class="limits">
		<p>
<?
	echo msg('limit by') . msg('limit group');

	// *** group selector
	//
	$gselect = array (
		"" => msg("pick group"),	// query
		"all" => msg("filter all"),		// all articles
		"none" => msg("filter none"),		// all articles, which aren't in any group
	);
	$gselect = $agroups->get_select_data ($gselect);
	$selected = isset ($agroup) ? $agroup : $agroup = "";
	if ($agroups->error_report () == false)
		render_select_box ("group", $gselect, $selected,
			"onChange=\"document.location.href='main.php?group='
			+ document.limits.group.options[selectedIndex].value\""
		);

	// *** limits: issue selector
	//
	echo msg('limit issue');
	//
	$issues->get ("name","ORDER BY id ASC");
	$selected = isset ($aissue) ? $aissue : $aissue="";
	if ($issues->error_report () == false)
		$issues->select_box (
			// name, col_values, col_texts, selected,
			"issue", "name", "name", $selected,
			// begin_values, end_values, attributes
			array (	"" => msg("pick issue"),
					"notpublished" => msg("filter not published")),
			"",
			"onChange=\"document.location.href='main.php?issue=' + document.limits.issue.options[selectedIndex].value\""
		);
	help (msg("noadd limits"));
?>
		</p>
	</div>
	</form>
<?

###############################################################################
# output

	// this <form> must be here everytime (even empty)
?>

	<div class="list">
	<form name="item_list" method="post">
<?
if ($display) {

	// NOTE: tables used in expression of LEFT JOIN in pgsql must be around the 'LEFT JOIN'
	// ie. not like this: Articles A, Users U LEFT JOIN Issues I ON (A.issue=I.id)
	//     but like this: Users U, Articles A LEFT JOIN Issues I ON (A.issue=I.id)
	if ($agroup != "") {
		if ($agroup == "all") {
			$q = "SELECT DISTINCT A.id, A.title, U.name, A.author_done, A.approved, I.name
			FROM Users U, Articles A LEFT JOIN Issues I ON (A.issue=I.id) WHERE A.author=U.id";
		} elseif ($agroup == "none") {
			$q = "SELECT A.id, A.title, U.name, A.author_done, A.approved, I.name
			FROM Users U, Articles A LEFT JOIN Ainsertion AG ON (A.id=AG.article)
			LEFT JOIN Issues I ON (A.issue=I.id)
			WHERE A.author=U.id AND AG.article IS NULL";
		} else {
			// some specific group
			$q = "SELECT A.id, A.title, U.name, A.author_done, A.approved, I.name
			FROM Agroups G, Ainsertion AG, Users U, Articles A LEFT JOIN Issues I ON (A.issue=I.id)
			WHERE A.author=U.id AND AG.article=A.id AND AG.agroup=G.id AND G.id='$agroup'";
		}
	} elseif ($aissue != "") {
		// TODO: display those published in groups too
		if ($aissue == "notpublished")
			// , '' works only in mysql
			$q = "SELECT DISTINCT A.id, A.title, U.name, A.author_done, A.approved
			FROM Articles A, Users U
			WHERE A.author=U.id AND A.published_on IS NULL";
		else
			$q = "SELECT DISTINCT A.id, A.title, U.name, A.author_done, A.approved, I.name
			FROM Articles A, Users U, Issues I
			WHERE A.author=U.id AND A.issue=I.id AND I.name='$aissue'";
	}
	
	// check rights -> display only own articles
	if (!$user->check_my ("a_correct") && !$user->check_my ("a_approve"))
		$q .= " AND A.author='{$user->id}'";
	// TEMP: until order selectable
	$q .= " ORDER BY A.title";
	$db->exec ($q, 1);
	warning ($db->report (msg("select fail"), ""));

	// *** table output
	if ($num = $db->num_rows ()) {

		// customize rendering (different counts of columns)
		$my_aset = $ASET_LIST;
		if (empty ($agroup) && $aissue == "notpublished")
			$my_aset->set ("td", array ('width="20"', '', '', 'align="center"', 'align="center"'));
		else 
			$my_aset->set ("td", array ('width="20"', '', '', 'align="center"', 'align="center"', ''));
	
		// prepare data
		$dr = new data_retriever_db ();
		$dr->prepare ($db);
		// prepare tag writer
		$tw = new tag_writer_taset ($my_aset);
		// create the list table using list_table class
		$table = new list_table_limited ($dr->format_array_2D(), $tw);
		//$table =& new list_table ($dr->format_array_2D(), $tw);
		$table->use_header (array ("", msg("list article title"), msg("list author"), 
			msg("list finished"), msg("list approved"), msg("list published")));
		$table->use_checkboxes (array (0), "A");
		$table->use_select_all (msg("select all"));
		$table->register_user_functions (array (
			1	=>	array (
					"list_table::to_link (\"%DATA%\", \"{$config["base_admin_url"]}/main.php?sec=edit&id=\", %DATA0%)",
					//"list_table::concat (\"%DATA%\", '&nbsp;('. list_table::to_link (\"detail\", \"javascript:popup_detail (%DATA0%)\", '') .')')"
					"list_table::concat (\"%DATA%\", '&nbsp;'. list_table::to_link (\"<img src=\\\"{$config["base_url"]}/images/lglass.gif\\\" height=11 border=0>\", \"javascript:popup_detail (%DATA0%)\", ''))"
				),
			3	=>	"list_table::to_boolean (%DATA%, msg(\"s_yes\"), \"<b>\".msg(\"s_no\").\"</b>\")",
			4	=>	"list_table::to_boolean (%DATA%, msg(\"s_yes\"), \"<b>\".msg(\"s_no\").\"</b>\")",
		), false);
		$table->set_pagesize ($user->page_size);

		// display
		$table->page_controls ();
		$table->display();

	} // if (num_rows)
} // if $display
?>
	</form>
	</div>
