<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################
# publish given articles

	$list =& $_GET['list'];
	$art_ids = get_array_from ($list);
	$ok = test ((count ($art_ids) > 0), alert_run (msg('not selected', 'article')));
	
	if ($ok) :
	// check rights
	$ok = test ($user->check_my ('a_publish'), alert_run (msg('no rights')));

	if ($ok) :

	// index prepare
	$index_present = $db->exec ('SELECT * FROM object_word_link LIMIT 1');
	if (!$index_present) {
		warning (msg("index not found") ."<br>\n");
	} else {
		info (msg('index found'));
		// disable time limit for this page
		ini_set ('max_execution_time', 0);
		require_once (INCLUDE_DIR .'/classes/class.fulltext_index.php');
		// TODO: indexed columns list as global setting ? 
		$s = new fulltext_index ('Articles', array ('content', 'title', 'subtitle'));
	}
	$indexed = 0;
		
	reset ($art_ids);
	while (list ($index, $id) = each ($art_ids)) {
		// publish into a group if
		//		not published at all
		// if published in an issue, it's not necessary since published_on is already set,
		//		so inserting into a group will make it visible

		// test if it's already published
		$a = $articles->get_one ('id, title, approved, published_on', "WHERE id='$id'");
		if ($a['approved'] != '1') {
			info (msg("publish not approved") . q($a['title']));
		} elseif ($a['published_on']) {
			info (msg("already published") . q($a['title']));
		} else {
			// test if it's in some group
			$ags = $articles->get_all_groups ($id, "G.id", "AND G.exported='1'");
			info ($db->report (msg('select fail')));
			if (empty ($ags)) {
				info (msg('publish no group') . q($a['title']));
			} else {
				$idate = datetime ();
				$db->exec ("UPDATE Articles SET 
					author_done='1', editor_done='1', approved='1', 
					published_on='$idate', publisher='$user_id'
					WHERE id='$id'", 1);
				info ($db->report (msg ('update fail'), msg('published article') . q($a['title'])));

				// *** create index
				if ($index_present) {
					$s->remove_item_index ($a['id']);
					$s->create_item_index ($a['id']);
					$indexed++;
				}
			}
		}
	}
	// TODO: make this info somehow more useful
	info (msg('index done') . " ($indexed)");
	endif;
	endif;
?>
