<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

class form_articles_relations extends form_process {
//------------------------------------------------//

	var $ddata;
	var $input;

	function prepare () {
		global $user, $articles, $ASET_LIST;
		
		if (isset ($_POST['list']))		$list =& $_POST['list'];
		elseif (isset ($_GET['list']))	$list =& $_GET['list'];

		$art_ids = get_array_from ($list);
		if (!test (count ($art_ids), alert_run (msg("not selected", "article"))))
			return false;

		// check rights
		/* NOTE: rights:
			a_create	.. everyone, who can create articles, can also select, which articles will be related to it
						.. but he can do that only while his article is in author mode
			a_approve	.. can re-set others' articles relationships (and must have a_create :-)
		 */
		if (!test ($user->check_my ("a_create"), alert_run (msg("no rights"))))
			return false;
		echo msg("form With following articles");
		echo "<blockquote>";
		// get the articles into array
		$this->input = array ();
		$display_data = array ();
		foreach ($art_ids as $id) {
			$a = $articles->get_one ('id, author, title, issue, author_done', "WHERE id='$id'");
			// allow only owned articles when user doesn't have a_approve
			if (!$user->check_my ("a_approve") && ($a['author'] != $user->id) )
				array_push ($display_data, array ($a['title'], msg("noown relating") ));
			// allow only while in author mode
			elseif (!$user->check_my ("a_approve") && $a['author_done'] == '1') {
				array_push ($display_data, array ($a['title'], msg("finished relating") ));
			} else {
				array_push ($display_data, array ($a['title'], ''));
				array_push ($this->input, $a);
			}
		}
		// customize rendering
		$my_aset = $ASET_LIST;
		$my_aset->set ("td", array ('', ''));
		// prepare data
		$dr =& new data_retriever ();
		$dr->prepare ($display_data);
		// prepare tag writer
		$tw =& new tag_writer_taset ($my_aset);
		// create the list table using list_table class
		$table =& new list_table_limited ($dr->format_array_2D(), $tw);
		$table->use_header (array (msg("list article title"), msg("list article symptoms")));
		$table->display ();
		echo "</blockquote>";

		// include the module, if we have some articles, that we can regroup
		if (count ($this->input))
			return true;
		else {
			info (msg("no article left"));
			return false;
		}
	}

	function custom_check () {
		if ($this->values['Action'] == "")
			$this->error ('Action', msg("no action selected"));
		if ($this->values['Action'] != "LIST" && $this->values['Anum'] > 1)
			if ($this->values['RArticle'] == "")
				$this->error ('RArticle', msg("no article selected"));
		if (!$this->values['Anum'])
			$this->error ('Anum', msg("no art left"));
	}

	function store_data () {
		global $db, $articles;
		$this->display_form ();

		// *** INSERT
		if ($this->values['Action'] == 'REL') {
			// is_numeric just for sure, the pre-removed articles don't appear here at all (so .. no 'while')
			if (is_numeric ($this->values["RArticle"])) {
				$art = $articles->get_one ("id, title", "WHERE id='".$this->values["RArticle"]."'");
			 	$first = $art['id'];
				$ftitle = $art['title'];
    		}
			$this->ddata = array ();
			for ($i=0; $i < $this->values['Anum']; $i++)
				if (is_numeric ($this->values["Article$i"]) && $this->values["Article$i"] != $first) {
					$aid = $this->values["Article$i"];
					$titles = stripslashes (q ($ftitle).", <br>".q($this->values["Atitle$i"]));
					if ($articles->are_related ($first, $aid)) {
						array_push ($this->ddata, array ($titles, msg("articles are related")) );
					} else {
						$db->exec ("INSERT INTO Arelated (this, that) VALUES ('$first', '$aid')", 1);
						array_push ($this->ddata, array ($titles, $db->report (msg("insert fail"), msg("saved")) ));
					}
				}
			$this->display_results (array (msg("list article title"), msg("list results")));

		// *** DELETE
		} elseif ($this->values['Action'] == 'UNR') {
			$this->ddata = array ();
			// 'unrelate all' action if one and only :-)
			if ($this->values['Anum'] == 1) {
				if (is_numeric ($this->values["Article0"])) {
					$aid = $this->values["Article0"];
					$title = stripslashes ($this->values["Atitle0"]);
					if (! count ($articles->get_related ($aid))) {
						array_push ($this->ddata, array ($title, msg("no relations present")));
					} else {
						$db->exec ("DELETE FROM Arelated WHERE this='$aid' OR that='$aid'", 1);
						array_push ($this->ddata, array ($title,
							$db->report (msg("delete fail"), msg("all relations removed")) ));
					}
     			}
			} else {
				// is_numeric just for sure, the pre-removed articles don't appear here at all (so .. no 'while')
				if (is_numeric ($this->values["RArticle"])) {
					$art = $articles->get_one ("id, title, menu_title", "WHERE id='".$this->values["RArticle"]."'");
					$first = $art['id'];
					$ftitle = $art['title'];
				}
				$this->ddata = array ();
				for ($i=0; $i < $this->values['Anum']; $i++)
					if (is_numeric ($this->values["Article$i"]) && $this->values["Article$i"] != $first) {
						$aid = $this->values["Article$i"];
						$titles = stripslashes (q ($ftitle).", <br>".q($this->values["Atitle$i"]));
						if ($articles->are_related ($first, $aid)) {
							$db->exec ("DELETE FROM Arelated WHERE
								(this='$first' AND that='$aid') OR (that='$first' AND this='$aid')", 1);
							array_push ($this->ddata, array ($titles, $db->report (msg("delete fail"), msg("removed")) ));
						} else {
							array_push ($this->ddata, array ($titles, msg("articles not related")) );
						}
					}
			}
			$this->display_results (array (msg("list article title"), msg("list results")));

		// *** LIST
		} elseif ($this->values['Action'] == 'LIST') {
			$this->display_list ($this->values['Anum'], '$this->values["Article$i"]', '$this->values["Atitle$i"]');
		} else
			info (msg("internal action"));
	}

	/**	Data rendering function.
	 *	It's common for all actions. Renders results into table using list_table.
	 *	@param	$theader	Array of table header strings.
	 *	@see	list_table
	 *	@see	taset
	 */
	function display_results ($theader) {
		global $gui, $ASET_LIST;
		echo "<hr>" . msg("form Results") . "<blockquote>";

		// TODO: prepare output : cut titles to some reasonable length
		/*
		function cut (&$art) {
			$art[0] = string_cut ($art[0], 50);
			$art[1] = string_cut ($art[1], 50);
		}
		array_walk ($this->ddata, 'cut');
		*/
		$my_aset = $ASET_LIST;
		$my_aset->set ("td", array ('', ''));
		
		// prepare data
		$dr =& new data_retriever ();
		$dr->prepare ($this->ddata);
		// prepare tag writer
		$tw =& new tag_writer_taset ($my_aset);
		// create the list table using list_table class
		$table =& new list_table_limited ($dr->format_array_2D(), $tw);
		$table->use_header ($theader);
		$table->display ();
		echo "</blockquote>";
	}

	/**	List rendering function.
	 *	This is kinda hack.
	 *	It's used both with the new values (from $garticles) and the form values ($this->values[])
	 *	so I had to make the assignments as parameters .. that are eval()-ed.
	 *	@param	$acount	Number of articles.
	 *	@param	$id_eval	Right side of the evaluated assignment to article id.
	 *	@param	title_eval	Right side of the evaluated assignment to article title.
	 */
	function display_list ($acount, $id_eval, $title_eval) {
		global $db, $articles;
		$this->ddata = array ();
		for ($i=0; $i < $acount; $i++) {
			eval ("\$aid = $id_eval;");
			if (is_numeric ($aid)) {
				$related = $articles->get_related ($aid);
				info ($db->report ($articles->get_error()));
				eval ("\$title = stripslashes ($title_eval);");
				$rel_line = "";
				foreach ($related as $ta)
					$rel_line .= q ($ta['title']) . ", <br>";
				array_push ($this->ddata, array ($title, $rel_line));
			}
   		}
		$this->display_results (array (msg("list article title"), msg("list related")));
	}

    function display_form () {
		global $db, $articles;
		$anum = count ($this->input);
		$t = new form_hidden ($this, "Anum", $anum);
		$t->display ();
		$this->error_report ('Anum');
		// deploy article ids
		for ($i=0; $i < $anum; $i++) {
			$t = new form_hidden ($this, "Article$i", $this->input[$i]['id']);
			$t->display ();
			$t = new form_hidden ($this, "Atitle$i", $this->input[$i]['title']);
			$t->display ();
		}
?>
		<input type="hidden" name="list" value="<?= $GLOBALS['list'];?>">
		<table>
			<?	// *** action select box
				if ($anum > 1) {
					$options = array (
						"" => msg("pick action"),
						"REL" => msg("relate to"),
						"UNR" => msg("unrelate from"),
						"LIST" => msg("get related"),
					);
					$t = new form_select ($this, 'Action', $options, "");
				} else {
					$options = array (
						"" => msg("pick action"),
						"UNR" => msg("unrelate all"),
						"LIST" => msg("get related"),
					);
					$t = new form_select ($this, 'Action', $options, "LIST");
				}
			?>
			<tr><td><?	$t->description ()	?></td>
				<td><?	$t->display (false);
						if ($anum > 1) {
							echo "&nbsp;";
							help (msg("relation basics"));
						}
						$this->error_report ('Action');
				?></td>
			</tr>
		<?	if ($anum > 1) :  
				// *** article select box
				$artsel[""] = msg("pick article");
				$idlist = '';
				foreach ($this->input as $ta)
					$idlist .= $ta['id'] .",";
				perl_chop ($idlist);
				$artsel = $articles->get_assoc ("id", "title", $artsel, "WHERE id IN ($idlist)");
				info ($db->report ($articles->get_error (), ""));
				$t = new form_select ($this, 'RArticle', $artsel, "");
		?>
			<tr><td><?	$t->description ()	?></td>
				<td><?	$t->display ();
						$this->error_report ('RArticle');
					?></td>
			</tr>
		<?	endif; ?>
		</table>
		</form>
<?		// display list if we have one article only
		// AND only if this is the first view of this page
		if ($anum == 1 && $this->first_time) {
   			$this->display_list ($anum, '$this->input[$i]["id"]', '$this->input[$i]["title"]');
  		}
	}

} // class

?>
