<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

class form_groups_edit extends form_process {
//-----------------------------------------//

	var $input;

	function prepare () {
		global $db, $user, $section, $agroups;
		
		if (isset ($_POST['id']))		$id =& $_POST['id'];	// from 'save' in edit
		elseif (isset ($_GET['id']))	$id =& $_GET['id'];		// from 'new'
		$list =& $_GET['list'];									// from list

		/* INPUT: edit types:
			1) new agroup => $section == 'new'
				+ save mode ... will save the article in DB and switch to author edit mode
			2) edit agroup => $section == 'edit'
		 */

		if ($section == "edit") {

			###############################################################################
			# 'edit' group
			
			// get INPUT : agroup id
			if (!$id)	// we can have the 'id' from 'new group'
				$id = get_first_from ($list); // if not, get it
			debug ("agroup id: $id");
			test ($id, alert_run (msg("not selected", "group")));
			$ok = test ($user->check_my ("agroups"), alert_run (msg("no rights")));
			if (!$ok)
				return false;
			// get group data ...
			$this->input = $agroups->get_one ("*", "WHERE id='$id'");
			info ($db->report ($agroups->get_error (), ""));
			test ($this->input, alert_run (msg("select fail")));

		} elseif ($section == "new") {

			###############################################################################
			# 'new' agroup
			
			// check rights
			$ok = test ($user->check_my ("agroups"), alert_run (msg("no rights")));
			// create input["column"] structure
			// this is important : set id to "" -> it's used to recognize "new" group
			$this->input = array (
				"id" => "",		"description" => "",
				"name" => "",	"menu_text" => "",
				"parent" => "",	"gorder" => "",
				"intro" => "",	"inline" => "0",
				"exported" => "",
			);
		} else
			failexit ("wrong section");
		return true;
	}

    function custom_check () {
		debug ("custom check");
		$this->_nonempty ("Name", msg("form Name error"));
		if ($this->values["Id"] != $this->values["Root"]) {
			$this->_nonempty ("Parent", msg("form Parent error empty"));
			if ($this->values["Id"] == $this->values["Parent"])
				$this->error ("Parent", msg("form Parent error same id"));
			// FIXME: this is strange, 0 could be allowed here,
			// but _nonempty implementation does not allow 0 as a value
			$this->_nonempty ("Gorder", msg("form Gorder error"));
		}
	}
	
	function store_data () {
		global $db;
		debug ("storing data");
		// retranslate checkbox data to db format
		$inline = isset ($this->values["Inline"]) ? '1' : '0';
		$exported = isset ($this->values["Exported"]) ? '1' : '0';
		if ($this->values["Id"] == "") {
			// *** 'new'
			// insert the new article group into DB
			$RS = $db->exec ("INSERT INTO Agroups
				(parent, gorder, name, menu_text, exported, description, intro, inline) VALUES
				('".$this->values["Parent"]."',
				 '".$this->values["Gorder"]."',
				 '".$this->values["Name"]."',
				 '".$this->values["Menu_text"]."',
				 '$exported',
				 '".$this->values["Description"]."',
				 '".$this->values["Intro"]."',
				 '$inline')", 1);
			info ($db->report (msg("insert fail")));
			if ($RS) {
				// get 'id' and move to edit
				$id = $db->last_insert_id ("agroups_id_seq");
				print "<SCRIPT>document.location.href='main.php?sec=edit&id=$id'</SCRIPT>\n";
			} else {
				// failed: if it's because of duplicate name:
				if ($db->get_db_id () == "MYSQL" && $db->errno() == "1062") {
					$this->error ('Name', msg("duplicate value"));
					$this->display_form ();
				// FIXME: missing error number
				} elseif ($db->get_db_id () == "PGSQL" && $db->errno() == "") {
					//$this->error ('Name', msg("duplicate value"));
					$this->display_form ();
				}
			}
		} else {
			// *** 'edit'
			// update the article in DB
			$q = "UPDATE Agroups SET ";
			if ($this->values["Id"] != $this->values["Root"])
				$q .= "	parent='".$this->values["Parent"]."',
						gorder='".$this->values["Gorder"]."',";
			$q .= "
				name='".$this->values["Name"]."',
				menu_text='".$this->values["Menu_text"]."',
				description='".$this->values["Description"]."',
				intro='".$this->values["Intro"]."',
				inline='$inline',
				exported='$exported'
				WHERE id='".$this->values["Id"]."'";
			$db->exec ($q, 1);
			info ($db->report (msg("update fail"), msg("saved")));
			$this->display_form ();
		}
	}

    function display_form () {
		global $db, $agroups, $ASET_LIST;
		// duplicate, on purpose, don't delete
		$t = new form_hidden ($this, 'Id', $this->input["id"]);
		$t->display ();
		$root = $agroups->get_one ("id", "WHERE parent IS NULL");
		$t = new form_hidden ($this, 'Root', $root["id"]);
		$t->display ();
		if ($this->input["id"] == $root["id"])
			info (msg("top level group"));
?>
		<input type="hidden" name="id" value="<?= $this->input["id"]?>">

		<table class="form">
		<?	// *** Group name
			$t = new form_text ($this, 'Name', $this->input["name"], 'size="50"');
			$this->_display_item ($t);
			
			// *** Visible name
			$t = new form_text ($this, 'Menu_text', $this->input["menu_text"], 'size="50"');
			$this->_display_item ($t);

			// *** Description
			$t = new form_text ($this, 'Description', $this->input["description"], 'size="50"');
			$this->_display_item ($t);
			
			// *** Intro
			$t = new form_textarea ($this, 'Intro', $this->input["intro"], 'cols="60" rows="3"');
			if ($t->visible ()) :
		?>
			<tr><td><?	$t->description () ?></td>
				<td><?	$t->display ();
						// place Richedit editor with link
						$editor = new richedit ("items",
							"<img src=\"./gui/img/richedit.gif\" alt=\"Richedit editor\" border=\"0\">");
						$editor->place ($t->input_name, 'wintro');
						//$editor->error_report ($t->name);
						if (isset ($editor->error)) {
							echo "&nbsp;";
							help (msg("richtext unavailable"));
						}
						$this->error_report ($t->name);
				?></td>
			</tr>
		<?	endif;

			// parent & gorder selection and exported only for non-root groups...
			if ($this->input["id"] != $root["id"]) :

			// *** Parent group
			$gselect[""] = msg("pick group");
			$gselect = $agroups->get_select_data ($gselect);
			info ($db->report ($agroups->get_error ()));
			// FIXME: not only the group itself should be cut,
			// byt the whole sub-tree under it :(
			if (is_numeric ($this->input["id"]))
				$gselect = array_cut ($this->input["id"], $gselect);
			$t = new form_select ($this, 'Parent', $gselect, $this->input["parent"], "onChange=\"submit();\"");
			$this->_display_item ($t);
		?>

			<tr><td valign="top"><?= msg("form current order") ?></td>
				<td><?	// *** group selector
						$parent = empty ($this->input["parent"]) ? $this->values["Parent"] : $this->input["parent"];
						if (!empty ($parent)) {
							$db->set_array_return_type ("NUM");
							$glist = $agroups->get ("gorder, name",
								"WHERE parent='".$parent."' ORDER by gorder, name");
							$db->set_array_return_type ();
							// customize rendering
							$my_aset = $ASET_LIST;
							$my_aset->set ("td", array ('width="10"', 'width="100"'));
							// prepare data
							$dr =& new data_retriever ();
							$dr->prepare ($glist);
							// prepare tag writer
							$tw =& new tag_writer_taset ($my_aset);
							// create the list table using list_table class
							$table =& new list_table_limited ($dr->format_array_2D(), $tw);
							$table->use_header (array (msg("edit group order"), msg("edit group name")));
							$table->display ();
						} else {
							warning (msg("n/a") ." - ". msg("form Gorder select parent"));
						}
				?></td>
			</tr>
		<?	// *** group index
			// FIXME: group order as selectbox?
			/* 
			$olist = array ();
			if (!empty ($parent)) {
				foreach ($glist as $g)
					$olist[$g[0]] = $g[0];
			} else {
				$olist[0] = 0;
			}
			$max = max (array_keys ($olist));
			$olist[$max+1] = $max+1;
			$gorder = empty ($this->input["gorder"]) ? $max+1 : $this->input["gorder"];
			new form_select ($this, 'Gorder', $olist, $this->input["gorder"]);
			*/
			$t = new form_text ($this, 'Gorder', $this->input["gorder"], 'size="2"');
			$this->_display_item ($t);
			
			// *** Inline articles
			$t = new form_checkbox ($this, 'Inline', $this->input["inline"], '');
			$this->_display_item ($t);

			// *** Exported
			$t = new form_checkbox ($this, 'Exported', $this->input["exported"], '');
			$this->_display_item ($t);
			
			// parent & gorder selection; exported .. not set
			
			endif;
		?>	
		</table>
		</form>
<?	}

} // class

?>
