<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

class form_groups_image extends form_process {
//------------------------------------------//

	var $input;
	var $aimages;
	var $empty;

	function prepare () {
		global $agroups, $images, $user;

		if (isset ($_POST['id']))		$id = $_POST['id'];
		elseif (isset ($_GET['id']))	$id = $_GET['id'];
		$list = $_GET['list'];

		// get input
		if (empty ($id))
			$id = get_first_from ($list);
		debug ("id: $id");
		test ($id, alert_run (msg("not selected", "group")));
		// check rights
		$ok = test ($user->check_my ("a_publish"), alert_run (msg("no rights")));
		if (!$ok)
			return false;
		// prepare form data
		$agroup = $agroups->get_one ("*", "WHERE id='$id'");
		test ($agroup, alert_run (msg("select fail")));
		$this->aimages = $images->get_all_assigned ("Agroups", $id);
		$this->input = array (
			'table' => 'Agroups',
			'id' => $id,
			'assigned' => $agroup['name'],
		);
		return true;
	}
	

    function custom_check () {
		global $images;
		debug ("custom check");
		//debug ("items to check: ".$this->values['Inum']);
		$idents = array ();
		for ($i=0; $i < $this->values['Inum']; $i++) {
			// filename given
            debug ("filename $i: ".$this->values["Filename$i"]);
			if (!empty ($this->values["Filename$i"])) {
				// try to find id if not set : everytime, filename might have changed
				$this->values["Image$i"] = $images->get_id ($this->values["Filename$i"]);
				// failed id or file does not exist
				if (!$this->values["Image$i"])
					$this->error ("Image$i", msg("non-existing image"));
                if (!$images->exists ($this->values["Image$i"]))
                    $this->error ("Image$i", msg("non-existing file"));
				// test unique ident
				else
					if (in_array ($this->values["Ident$i"], $idents))
						$this->error ("Ident$i", msg("ident not unique"));
					else
						array_push ($idents, $this->values["Ident$i"]);
			}
		}
	}

	function store_data () {
		global $db, $images;
		debug ("storing data");
		//debug ("items to save: ".$this->values['Inum']);
		$images->unassign_all ($this->values['Table'], $this->values['Id']);
		info ($db->report ($images->get_error ()));
		$ok = true;
		// detect empty boxes
		$this->empty = array ();
		for ($i=0; $i < $this->values['Inum']; $i++) {
			if (!empty ($this->values["Filename$i"])) {
				$line = array (
					'table'		=> $this->values["Table"],
					'id'		=> $this->values['Id'],
					'image'		=> $this->values["Image$i"],
					'ident'		=> $this->values["Ident$i"],
					'options'	=> $this->values["Options$i"]
				);
				$images->assign ($line);
				info ($db->report ($images->get_error (),
					"{$this->values["Filename$i"]}/{$this->values["Ident$i"]} ".msg("saved")));
				if ($images->get_error () != '')
					$ok = false;
			} else
				array_push ($this->empty, $i);
		}
		//if ($ok)
		//	info (msg("saved"));
		$this->aimages[count ($this->aimages)] = array (
			'id' => '', 'filename' => '',
			'ident' => '', 'options' => '',
		);
		$this->display_form ();
	}

    function display_form () {
		global $images, $ASET_LIST;
		$inum = count ($this->aimages);
		// add one empty box
		if ((isset ($this->empty) && count ($this->empty) == 0) || !isset ($this->empty))
			$this->aimages[$inum++] = array (
				'id' => '', 'filename' => '',
				'ident' => '', 'options' => '',
			);
		// reset count and deploy hidden forms
		$this->values["Inum"] = $inum;
		$t = new form_hidden ($this, "Inum", $inum);
		$t->display ();
		$t = new form_hidden ($this, "Table", $this->input["table"]);
		$t->display ();
		$t = new form_hidden ($this, "Id", $this->input["id"]);
		$t->display ();
?>
		<input type="hidden" name="table" value="<?= $this->input["table"]?>">
		<input type="hidden" name="id" value="<?= $this->input["id"]?>">

		<table border="1">
			<tr><td colspan="3">
			<?	echo msg("assign images") ." ". q($this->input['assigned']);
				//help (msg("specific image")); ?></td>
			</tr>
			<?	//$ibrowser =& new image_browser_db ($images, '');
				$dr = new data_retriever_db_images ();
				$dr->prepare ($images, '');
				$ibrowser = new image_browser (
					$dr->format_array_2D (),
					new tag_writer_taset ($ASET_LIST),
					$images);
				for ($i=0; $i < $inum; $i++) { ?>
			<tr valign="top"><td width="300">
			<?	$img = new form_hidden ($this, "Image$i", $this->aimages[$i]['id']);
				$img->display ();
				$image_form = new form_text ($this, "Filename$i", $this->aimages[$i]['filename'], 'size="20"');
				$image_form->display ();
				echo "&nbsp;";
				if ($image_form->value && $tmp = $images->get_one ("*", "WHERE id='".$img->value."'"))
					$images->preview_button ($tmp['id'], 
						$images->get_full_url ($tmp['id'], $tmp['filename']), 
						$tmp['width'], $tmp['height'], true);
				$ibrowser->browser_button ("items", $image_form->input_name);
				$this->error_report ("Image$i");
				?></td>
			<?	// *** Identification
				$t = new form_text ($this, "Ident$i", $this->aimages[$i]['ident'], 'size="20"');
				$t->msg_description = "form Ident";
			?>
				<td width="100"><?	$t->description () ?></td>
				<td width="300"><?	$t->display ();
									$this->error_report ("Ident$i");
				?></td>
			</tr>
			<tr><td></td>
				<?	// *** Options
					$t = new form_text ($this, "Options$i", $this->aimages[$i]['options'], 'size="20"');
					$t->msg_description = "form Options";
				?>
				<td><?	$t->description () ?></td>
				<td><?	$t->display ();
						$this->error_report ("Options$i");
				?></td>
			</tr>
		<?	}	?>
		</table>
		</form>
<?	}

} // class

?>
