<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

class form_groups_order extends form_process {
//------------------------------------------//

	var $input;

	function prepare () {
		global $db, $user, $agroups;
	
		$id = isset ($_POST['id']) ? $_POST['id'] : null; 
		$list = isset ($_GET['list']) ? $_GET['list'] : null;

		if (!$id)	// we can have the 'id' from 'new group'
			$id = get_first_from ($list); // if not, get it
		debug ("agroup id: $id");
		test ($id, alert_run (msg("not selected", "group")));
		// check rights
		$ok = test ($user->check_my ("agroups"), alert_run (msg("no rights")));
		if (!$ok)
			return false;
		// get group data & create agroup["column"] structure ...
		$this->input = $agroups->get_one ("*", "WHERE id='$id'");
		info ($db->report ($agroups->get_error (), ""));
		test ($this->input, alert_run (msg("select fail")));
		return true;
	}
	
	function custom_check () {
		debug ("custom check");
	}
	
	function store_data () {
		global $db;
		debug ("storing data");
		// update agroup order for every article
		for ($i=0; $i < $this->values['Anum']; $i++) {
			//debug ("A $i id: ". $this->values["Article$i"]);
			if (is_numeric ($this->values["Article$i"])) {
				$db->exec ("UPDATE Ainsertion SET
					aorder='".($i+1)."'
					WHERE article='".$this->values["Article$i"]."' 
					AND agroup='".$this->values["Id"]."'", 1);
				info ($db->report (msg("update fail", msg("saved")))); // , msg("saved")  .. for every article
			}
		}
		$this->display_form ();
	} // store_data
	
    function display_form () {
		global $db, $articles;
		$t = new form_hidden ($this, 'Id', $this->input["id"]);
		$t->display ();
?>
		<input type="hidden" name="id" value="<?= $this->input["id"] ?>">
		<table>	
		<?	// *** article select box
			// prepare articles select box to $options
			$selected = array ();
			// get agroup articles into an array
			$arts = $articles->get_group ($this->input['id']);
			info ($db->report ($articles->get_error ()));
			foreach ($arts as $art) {
				//$options[$art['id']] = title_cut ($art['title']);
				$options[$art['id']] = $art['title'];
				array_push ($selected, $art['id']);
			}
		?>
			<tr><td colspan="2"><?= msg("article order") . q($this->input["name"]) ." :" ?>
			</td></tr>
		<?	// display list
			if (count ($selected)) {

				// number of articles
				$t = new form_hidden ($this, 'Anum', count ($selected));
				$t->display ();
				// select boxes with switches
				for ($i=0; $i < count ($selected)-1; $i++) {
					echo "<tr><td align=\"right\" width=\"100\">".($i+1).":</td><td>";
					$temp_sel = isset ($this->values["Article$i"]) ? $this->values["Article$i"] : $selected[$i];
					$t = new form_select ($this, "VArticle$i", $options, $temp_sel, "disabled");
					$t->display ();
					$t = new form_select ($this, "Article$i", $options, $temp_sel, "style=\"display: none\"");
					$t->display ();
					$t = new form_button ($this, "Aswitch$i", "V", "onclick=\"
						switch_values ('{$this->field_prefix}{$this->name}', 'Article$i', 'Article".($i+1)."');
						switch_values ('{$this->field_prefix}{$this->name}', 'VArticle$i', 'VArticle".($i+1)."');
					\"");
					$t->display ();
					echo "</td></tr>\n";
				}
				// last select
				echo "<tr><td align=\"right\" width=\"100\">".($i+1).":</td><td>";
				$temp_sel = isset ($this->values["Article$i"]) ? $this->values["Article$i"] : $selected[$i];
				$t = new form_select ($this, "VArticle$i", $options, $temp_sel, "disabled");
				$t->display ();
				$t = new form_select ($this, "Article$i", $options, $temp_sel, "style=\"display: none\"");
				$t->display ();
				echo "</td></tr>\n";
				
			} else {
				echo "<tr><td>";
				info (msg("no articles present"));
				echo "</td></tr>\n";
			}
		?>
		</table>
		</form>
<?	}

} // class

?>
