<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

class form_images_edit extends form_process {
//-----------------------------------------//

	var $input;

	function prepare () {
		global $section, $user, $images;

		if (isset ($_POST['id']))		$id = $_POST['id'];
		elseif (isset ($_GET['id']))	$id = $_GET['id'];
		$list = isset ($_GET['list']) ? $_GET['list'] : null;

		if ($section == "edit") {

			###############################################################################
			# 'edit' image
			
			// get INPUT : image id
			if (!$id)
				$id = get_first_from ($list); // if not, get it
			debug ("image id: $id");
			test ($id, alert_run (msg("not selected", "image")));
			// check rights
			if (test ($user->check_my ("a_publish"), alert_run (msg("no rights")))) {
				// 'issues' to manipulate all images
				$this->input = $images->get_one ("*", "WHERE id='$id'");
				if (!test ($this->input, alert_run (msg("select fail"))))
					return false;
			} elseif ( test ($user->check_my ("a_create"), alert_run (msg("no rights"))) ) {
				// 'a_create' to manipulate own images
				$this->input = $images->get_one ("*", "WHERE id='$id'");
				test ($this->input, alert_run (msg("select fail")));
				if (!$user->check_my ("admin")) {
					test ($this->input['owner'] == $user_id, alert_run (msg("no rights")));
					return false;
				}
			}

		} elseif ($section == "new") {
		/*
			###############################################################################
			# 'new' image
			
			// check rights
			test ($user->check_my ("a_publish"), alert_run (msg("no rights")));
			// prepare form data
			$image = array (
				"anum" => "3",
				"id" => "", 	"name" => "", 
				"volume" => "",	"subtitle" => "",
			);
		*/
		} else
			failexit ("wrong section");
		return true;
	}
	
    function custom_check () {
		global $images;
		debug ("custom check");
		if (empty ($this->Values['Filename']))
			$this->error ('Filename', msg("no filename", "image"));
		elseif ( ($this->Values['Filename'] != $this->Values['OldFilename'])
			  && !$images->is_unique ($this->Values['Filename']) )
			$this->error ('Filename', msg("rename not unique"));
		// this should never happen
		elseif (!$images->exists ($this->Values['Id']))
			$this->error ('Filename', msg("internal file"));
	}
	
	function store_data () {
		global $db, $images, $user;
		debug ("storing data");
		if ($dir = $images->get_dir ($this->Values['Id'])) {
			if (!rename ($dir.'/'.$this->Values['OldFilename'], $dir.'/'.$this->Values['Filename'])) {
				info (msg("rename failed"));
				return false;
			}
			$owner = ($user->check_my ("admin") && isset ($this->Values["Owner"])) ?
				", owner='".$this->Values["Owner"]."'" : "";
			// update the item in DB
			$db->exec ("UPDATE Images SET
				filename='".$this->Values["Filename"]."',
				href='".$this->Values["Href"]."',
				description='".$this->Values["Description"]."'
				$owner
				WHERE id='".$this->Values["Id"]."'", 1);
			info ($db->report (msg("update fail"), msg("saved")));
			$this->display_form ();
		} else
			info (msg("cant get dir"));
	}

    function display_form () {
		global $db, $images, $user, $users;
		$t = new form_hidden ($this, 'Id', $this->input["id"]);
		$t->display ();
?>
		<input type="hidden" name="id" value="<?= $this->input["id"]?>">
		<table class="form">
			<?	// *** Filename
				$ot = new form_hidden ($this, 'OldFilename', $this->input["filename"], 'size="40"');
				$t = new form_text ($this, 'Filename', $this->input["filename"], 'size="40"');
			?>
			<tr><td><?	$t->description () ?></td>
				<td><?	$ot->display ();
						$t->display ();
						$this->error_report ($t->name);	?></td>
			</tr>
			<?	// *** Href
				$t = new form_text ($this, 'Href', $this->input["href"], 'size="40"');
			?>
			<tr><td><?	$t->description () ?></td>
				<td><?	$t->display ();
						$this->error_report ($t->name);	?></td>
			</tr>
			<?	// *** Subtitle
				$t = new form_textarea ($this, 'Description', $this->input["description"], 'cols="60" rows="3"');
			?>
			<tr><td><?	$t->description () ?></td>
				<td><?
					// place Richedit editor with link
					$t->display ();
					$editor = new richedit ("items",
						"<img src=\"./gui/img/richedit.gif\" alt=\"Richedit editor\" border=0>");
					$editor->place ($t->input_name, 'wdescription');
					//$editor->error_report ();
					if (isset ($editor->error)) {
						echo "&nbsp;";
						help (msg("richtext unavailable"));
					}
					$this->error_report ($t->name);
				?></td>
			</tr>
			<?	// *** Owner
				if ($user->check_my ("admin")) {
					$uoptions[""] = msg("pick user");
					$uoptions = $users->get_assoc ("id", "name", $uoptions, "ORDER by name");
					info ($db->report ($users->get_error ()));
					$t = new form_select ($this, 'Owner', $uoptions, $this->input['owner']);
					$this->error_report ('Owner');
				} else {
					$owner = $users->get_one ("name", "WHERE id='".$this->input['owner']."'");
					$t = new form_plaintext ($this, 'Owner', $owner["name"]);
				} 
			?>
			<tr><td><?	$t->description () ?></td>
				<td><?	$t->display ();
						$this->error_report ($t->name);	?></td>
			</tr>
			<?	// *** Preview
				$t = new form_string ($this, 'Preview', '', 'size="40"');
			?>
			<tr><td><?	$t->description () ?></td>
				<td><?	// TODO: max preview size?
						echo $images->get_tag ($this->input['id'], $this->values['Filename']);
				?></td>
			</tr>
		</table>
		</form>
<?	}

} // class

?>
