<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################
# edit issue (used for 'new issue' and 'edit issue'

// create volume db entity (used only here)
$volumes = new db_entity ("Volumes");


class form_wizard_issues_edit extends form_wizard { 
//-----------------------------------------------//

	var $input;

	/** Maximum length of displayed article title.
	 */
	var $title_maxlen;
	
	function title_cut ($string) {
		return string_cut ($string, $this->title_maxlen);
	}
	
	function prepare () {
		global $module, $section, $user, $issues;

		$this->title_maxlen = 75;
		
		if (isset ($_POST['id']))		$id = $_POST['id'];		// from 'save' in edit
		elseif (isset ($_GET['id']))	$id = $_GET['id'];		// from 'new'
		$list = isset ($_GET['list']) ? $_GET['list'] : null;	// from list

		/* INPUT: edit types:
			1) new issue => $section == 'new'
				+ save mode ... will save the issue in DB and switch to edit mode
			2) edit issue => $section == 'edit'
		 */

		if ($section == "edit") {

			###############################################################################
			# 'edit' issue
			
			// get INPUT : issue id
			if (!$id)	// we can have the 'id' from 'new issue' or issue sequence
				$id = get_first_from ($list); // if not, get it
			debug ("issue id: $id");
			test ($id, alert_run (msg("not selected", "issue")));
			// check rights
			$ok = test ($user->check_my ("a_publish"), alert_run (msg("no rights")));
			if (!$ok)
				return false;

			// TODO: notice about editing current/published issue
			// prepare form data
			$this->input = $issues->get_one ("*", "WHERE id='$id'");
			test ($this->input, alert_run (msg("select fail")));

		} elseif ($section == "new") {

			###############################################################################
			# 'new' issue
			
			test ($user->check_my ("a_publish"), alert_run (msg("no rights")));
			// prepare form data
			$this->input = array (
				"anum" => "3",
				"id" => "", 	"name" => "", 
				"volume" => "",	"menu_title" => "",
				"subtitle" => "",
			);
		} else
			return false;

		// *** require wizard parts
		require_once INCLUDE_DIR ."/modules/$module/include/edit_1.php";
		require_once INCLUDE_DIR ."/modules/$module/include/edit_2.php";
		require_once INCLUDE_DIR ."/modules/$module/include/edit_3.php";
		
		// define the sequence for the wizard
		$this->states = array (
			array ("class" => "form_issues_edit_1"),
			array ("class" => "form_issues_edit_2"),
			array ("class" => "form_issues_edit_3"),
			// TODO: one more?: info, images move ?, .......
			array ("terminator" => array (
				"text" => msg("form Issue saved"),
				"var" => "id"
			)),
		);
		
		debug ($this->current);
		debug ($this->session_var);
		return true;
	}

}	// class

?>
