<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

/**	
 *	issues:edit - edit issue name and select articles.
 *	
 *	@author	Jan Hnatek
 */
class form_issues_edit_1 extends form_process {
//-------------------------------------------//

	var $input;
	
	// wizards have common prepare, it's not needed here
	// still, it must return true to display the form
	function prepare () {
		$this->input = $this->wizard->input;
		return true;
	}
	
    function custom_check () {
		debug ("custom check: 1");
		//debug ("VolumeId: ".$this->values['Volume']);
		//debug ("NewVolume: ".$this->values['NewVolume']);
		//debug ("NewVolumeName: ".$this->values['NewVolumeName']);
		
		// handle add/del : +fake an error, so we don't advance in the wizard
		if (isset ($this->values['Add']) && $this->values['Add'] == msg('add')) {
			$this->error ('Add', 'fake');
			$this->values['Anum']++;
		}
		if (isset ($this->values['Del']) && $this->values['Del'] == msg('del')) {
			$this->error ('Del', 'fake');
			$this->values['Anum']--;
		}
		// check input
		$this->_nonempty ("Name", msg("no name", "issue"));
		if (isset ($this->values['NewVolume']))
			$this->_nonempty ("NewVolumeName", msg("no name", "volume"));
		elseif ($this->values['NewVolumeName'] && $this->values['Volume'])
			$this->error ('NewVolumeName', msg("form NewVolumeName error"));
	}
	
	function store_data () {
		global $db;
		debug ("storing data: 1");
		// select volume
		if (isset ($this->values['NewVolume'])) {
			// insert the new volume into DB
			$rs = $db->exec ("INSERT INTO Volumes (name) VALUES ('".$this->values['NewVolumeName']."')", 1);
			info ($db->report (msg("insert fail"), msg("saved")));
			$volume = "'".$db->last_insert_id ("issues_id_seq")."'";
		} elseif ($this->values['Volume'])
			$volume = "'".$this->values['Volume']."'";
		else
			$volume = "NULL";
		// if it's really a submit (the correct one; 'add'/'del' only modify the form)
		if (!isset ($this->values['Add']) && !isset ($this->values['Del'])) {
			if ($this->values["Id"] == "") {
				// *** 'new'
				// insert the new issue into DB
				$rs = $db->exec ("INSERT INTO Issues (name, menu_title, subtitle, volume) VALUES (
					'".$this->values['Name']."',
					'".$this->values['Menu_title']."',
					'".$this->values['Subtitle']."',
					$volume)", 1);
				info ($db->report (msg("insert fail"), msg("saved")));
				if ($rs) {
					$id = $db->last_insert_id ("issues_id_seq");
					// update issue info in every article in the new issue
					for ($i=0; $i < $this->values['Anum']; $i++) {
						debug ("A $i id: ". $this->values["Article$i"]);
						// TODO: ? test article approved ? 
						// or ignore it for a while (can be selected through query in selectbox $articles->get_new ())
						if (is_numeric ($this->values["Article$i"])) {
							$db->exec ("UPDATE Articles SET 
								issue='$id', iorder='$i' WHERE id='".$this->values["Article$i"]."'", 1);
							info ($db->report (msg("update fail")));
						} // if is_numeric (article id)
					} // for all $anum
					// move to edit with $id
					print "<SCRIPT>document.location.href='main.php?sec=edit&id=$id'</SCRIPT>\n";
				} // if ($rs) of Issue INSERT
			} else {
				// *** 'edit'
				// update the issue in DB
				$db->exec ("UPDATE Issues SET 
					name='".$this->values['Name']."',
					menu_title='".$this->values['Menu_title']."',
					subtitle='".$this->values['Subtitle']."',
					volume=".$volume." WHERE id='".$this->values['Id']."'", 1);
				info ($db->report (msg("update fail"), msg("saved")));
				// clear Articles.issue values (the old one)
				$db->exec ("UPDATE Articles SET issue=NULL WHERE issue='".$this->values['Id']."'", 1);
				info ($db->report (msg("update fail")));
				$idate = datetime ();
				// update issue info in every article in the new issue
				for ($i=0; $i < $this->values['Anum']; $i++) {
					if (is_numeric ($this->values["Article$i"])) {
						// TODO: ? test article approved ?
						$db->exec ("UPDATE Articles SET
							issue='".$this->values['Id']."',
							iorder='$i'
							WHERE id='".$this->values["Article$i"]."'", 1);
						info ($db->report (msg("update fail"))); // , msg("saved")  .. for every article
						// update articles published_on, if not set
						$db->exec ("UPDATE Articles SET published_on='$idate' WHERE published_on IS NULL", 1);
						info ($db->report (msg("update fail")));
					} // is_numeric
				} // for each $anum
			} // *** 'new' / 'edit'
		}
	} // store_data ()
	
    function display_form () {
		global $articles, $volumes, $db;
		// duplicate on purpose, don't delete
		$t = new form_hidden ($this, 'Id', $this->input["id"]);
		$t->display ();
?>
		<input type="hidden" name="id" value="<?= $this->input["id"] ?>">
		<table class="form">
		<?	// *** Name
			$t = new form_text ($this, 'Name', $this->input["name"], 'size="70"');
		?>				
			<tr><td><?	$t->description () ?></td>
				<td colspan="2"><?
						$t->display ();
						$this->error_report ($t->name);	?></td>
			</tr>
			
		<?	// *** Menu_title
			$t = new form_text ($this, 'Menu_title', $this->input["menu_title"], 'size="70"');
			if ($t->visible ()) :
		?>				
			<tr><td><?	$t->description () ?></td>
				<td colspan="2"><?
						$t->display ();
						$this->error_report ($t->name);	?></td>
			</tr>
		<?	endif;

			// *** Subtitle
			$t = new form_text ($this, 'Subtitle', $this->input["subtitle"], 'size="70"');
			if ($t->visible ()) :
		?>
			<tr><td><?	$t->description () ?></td>
				<td colspan="2"><?
						$t->display ();
						$this->error_report ($t->name);	?></td>
			</tr>
		<?	endif;

			// *** Volume
			$voloptions[""] = msg("pick volume");
			$voloptions = $volumes->get_assoc ("id", "name", $voloptions, "ORDER by id");
			info ($db->report ($volumes->get_error ()));
			$t = new form_select ($this, 'Volume', $voloptions, $this->input["volume"]);
			$nvn = new form_text ($this, 'NewVolumeName', "", 'size="15"');
			$nv = new form_checkbox ($this, 'NewVolume', '', '');
		?>
			<tr><td><?	$t->description () ?></td>
				<td colspan="2"><?
					// volume selector
					$t->display ();
					$this->error_report ($t->name);
					echo "&nbsp;";
					
					// create new volume
					$nvn->description ();
					$nv->display ();
					$nvn->display ();
					$this->error_report ($nvn->name);
				?></td>
			</tr>
		
		<?	// *** Articles
			$add = new form_submit ($this, 'Add', msg('add'), 'title="'.msg("form Articles more").'" class="button"');
			$del = new form_submit ($this, 'Del', msg('del'), 'title="'.msg("form Articles less").'" class="button"');

			// *** prepare articles select box .. to $options array
			$options[' '] = msg('pick article');
			$selected = array ();
	//$menu_titles = array ();
			// get issue articles into an array, but only when this is 'edit'
			if ($this->input['id'] != "") {
				$arts = $articles->get_issue ($this->input['id']);
				// FIXME: depends on implementation in mysql_db -> ???? should be ok now
				//info ($db->report ($articles->get_error ()));
				foreach ($arts as $art) {
					$options[$art['id']] = $this->wizard->title_cut ($art['title']);
					array_push ($selected, $art['id']);
	//$menu_titles[$art['id']] = ''; //art['item'];
				}
				// add separator
				$options['  '] = "------------------";
				$new = 1;
			} else
				// add 3 new article select boxes
				$new = 3;
			// add new articles
			$arts = $articles->get_new ();
			info ($db->report ($articles->get_error ()));
			foreach ($arts as $art) {
				$options[$art['id']] = $this->wizard->title_cut ($art['title']);
	//$menu_titles[$art['id']] = $art['item'];
			}
		?>	
			<tr><td><?= msg("form Articles") ?></td>
				<td><?
				$add->display ();
				echo "&nbsp;";
				$del->display ();
				echo "&nbsp;";
				help (msg("form Articles help"));
				?></td></tr>
			<?	// display Articles
				$anum = (isset ($this->values['Anum'])) ? $this->values['Anum'] : count ($selected) + $new;
				$t = new form_hidden ($this, 'Anum', $anum);
				$t->display ();
				for ($i=0; $i < $anum-1; $i++) {
					echo "<tr><td align=\"right\">".($i+1).":</td><td>";
					$temp_sel = isset ($selected[$i]) ? $selected[$i] : "";
					$t = new form_select ($this, "Article$i", $options, $temp_sel);
					$t->display ();
					$t = new form_button ($this, "Aswitch$i", "v", 
						"onclick=\"switch_values ('{$this->field_prefix}{$this->name}', 'Article$i', 'Article".($i+1)."');\"");
					$t->display ();
					echo "</td></tr>\n";
				}
				// last select
				echo "<tr><td align=\"right\" width=\"100\">".($i+1).":</td><td>";
				$temp_sel = isset ($selected[$i]) ? $selected[$i] : "";
				$t = new form_select ($this, "Article$i", $options, $temp_sel);
				$t->display ();
				echo "</td></tr>\n";

		?>
		</table>&nbsp;
		</form>
<?	}

} // class

?>
