<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

/**	
 *	issues:publish - index creation, etc.
 *	
 *	@author	Jan Hnatek
 */
class form_issues_publish_1 extends form_process {
//----------------------------------------------//

	var $input;
	
	// wizards have common prepare, it's not needed here
	// still, it must return true to display the form
	function prepare () {
		$this->input = $this->wizard->input;
		return true;
	}
	
    function custom_check () {
		debug ("custom check: 1");
	}
	
	function store_data () {
		global $db, $articles, $issues, $user_id;
		debug ("storing data: 1");
		$id = $this->values["Id"];

		// *** create index
		if (isset ($this->values["Index"])) {
			info (msg("create index") ." $id");
			$arts = $articles->get_issue ($id);
			$index_present = $db->exec ("SELECT * FROM object_word_link LIMIT 1");
			if (!$index_present) {
				warning (msg("index not found") ."<br>\n");
			} else {
				info (msg("index found"));
			
				require_once (INCLUDE_DIR ."/classes/class.fulltext_index.php");
				// TODO: indexed columns list as global setting ? 
				$s = new fulltext_index ("Articles", array ("content", "title", "subtitle"));
				// disable time limit for this page
				ini_set ("max_execution_time", 0);
				
				foreach ($arts as $a) {
					$s->remove_item_index ($a["id"]);
					// FIXME: style
					echo "<p class=\"txt\">";
					$s->create_item_index ($a["id"]);
					echo "</p>";
				}
				info (msg("index done"));
			}
			echo "<br>";
		}
		
		// *** TODO: set deadline ...
		//$db->exec ("UPDATE issues SET deadline ...");
		// save this value to deadline_next of published issue ??
		// or make it as a part of some message system
		
		// *** unpublish current issue
		// optionally move to archive
		if (isset ($this->values["Archive"]))
			$db->exec ("UPDATE Issues SET current='0', archived='1' WHERE current='1'", 1);
		else
			$db->exec ("UPDATE Issues SET current='0' WHERE current='1'", 1);

		// *** publish issue
		// select published issue
		$db->exec ("SELECT id, name FROM Issues WHERE current='1'", 1);
		while (list ($iid, $name) = $db->get_result ())
			info (msg("unpublishing issue") ."'$name'");
		// publish the one selected
		$this->input = $issues->get_one ("*", "WHERE id='$id'");
		$idate = datetime ();
		$db->exec ("UPDATE Issues SET current='1', published_on='$idate', archived='0' WHERE id='$id'", 1);
		info ($db->report (msg("update fail")));
		// update articles
		$db->exec ("UPDATE Articles SET published_on='$idate', publisher='$user_id' WHERE issue='$id'", 1);
		info ($db->report (msg("update fail"), msg("published issue"). "'".$this->input['name']."'"));
		
	} // store_data ()
	
    function display_form () {
		global $users;
		$t = new form_hidden ($this, 'Id', $this->input["id"]);
		$t->display ();
?>
		<input type="hidden" name="id" value="<?= $this->input["id"]?>">
		<table>
			<?	// *** Fulltext index
				$t = new form_checkbox ($this, 'Index', 'off', '');
			?>
			<tr><td><?	$t->description () ?></td>
				<td><?	$t->display ();	?></td>
			</tr>
			<?	// *** Archive
				$t = new form_checkbox ($this, 'Archive', 'on', '');
			?>
			<tr><td><?	$t->description () ?></td>
				<td><?	$t->display ();	?></td>
			</tr>
		<?	/*
			// TODO: deadline
			if (empty ($this->input["deadline"]))
				$this->input["deadline"] = date ("Y-m-d");
		?>
			<tr><td>Specify deadline for next issue:</td>
				<td><?	new form_text ($this, 'Deadline', $this->input["deadline"], 'size="10" class="text"');
						$this->error_report ('Deadline'); ?></td>
			</tr>
		 	*/
		?>
		</table>
		</form>
<?	}

} // class

?>
