<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

/**	
 *	issues:publish - notification, publishing
 *	
 *	@author	Jan Hnatek
 */
class form_issues_publish_2 extends form_process {
//----------------------------------------------//

	var $input;
	
	// wizards have common prepare, it's not needed here
	// still, it must return true to display the form
	function prepare () {
		$this->input = $this->wizard->input;
		return true;
	}
	
    function custom_check () {
		debug ("custom check: 2");
		// check recipients
		if (isset ($this->values['Notify'])) {
			$this->_nonempty ("Notification", msg("form Notification error"));
			$this->_nonempty ("Recipients", msg("form Recipients error"));
			// TODO: check recipients format?
		}
	}
	
	function store_data () {
		global $db;
		debug ("storing data: 2");

		if (isset ($this->values['Notify'])) {
			// *** send notification
			$mail_tool = new mailer_db ($GLOBALS["ADMIN_EMAIL"]);
			if ($mail_tool->send_notification (msg("new issue published"),
				$this->values["Notification"], $this->values["Recipients"])) {
				info ("notification message sent ok");
			} else
				warning ("notification sending failed");
		}

	} // store_data ()
	
    function display_form () {
		$t = new form_hidden ($this, 'Id', $this->input["id"]);
		$t->display ();
?>
		<input type="hidden" name="id" value="<?= $this->input["id"]?>">
		<table>
			<?	// *** Send notification
				$t = new form_checkbox ($this, 'Notify', '', '');
			?>
			<tr><td><?	$t->description () ?></td>
				<td><?	$t->display ();	?></td>
			</tr>
		</table>
		<table>
			<?	// *** Notification text
				$mail_tool = new mailer_db ();
				$message = $mail_tool->compile_issue_notification ($this->input["id"]);
				// allow message edit
				$t = new form_textarea ($this, 'Notification', $message, 'rows="10" cols="70"');
			?>
			<tr><td valign="top"><?	$t->description () ?></td>
				<td><?	$t->display ();
						$this->error_report ('Notification');
				?></td>
			</tr>
			<?	// *** Notification recipients
				$elist = $mail_tool->prepare_recipients_issue ();
				$t = new form_textarea ($this, 'Recipients', $elist, 'rows="15" cols="30"');
			?>
			<tr><td valign="top"><?	$t->description () ?></td>
				<td><?	$t->display ();
					$this->error_report ('Recipients');
				?></td>
			</tr>
		</table>
		</form>
<?	}

} // class

?>
