<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################

class form_users_edit extends form_process {
//----------------------------------------//

	var $input;
	
	function prepare () {
		global $db, $user, $users, $section, $config;

		if (isset ($_POST['id']))		$id = $_POST['id'];		// from 'save' in edit
		elseif (isset ($_GET['id']))	$id = $_GET['id'];		// from 'new'
		$list = isset ($_GET['list']) ? $_GET['list'] : null;	// from list

		/* INPUT: edit types:
			1) new user => $section == 'new'
				+ save mode ... will save the article in DB and switch to user edit mode
			2) edit user => $section == 'edit'
		 */

		if ($section == "edit") {

			###############################################################################
			# 'edit' user parameters

			// get INPUT : user id
			if (!$id)	// we can have the 'id' from 'new user'
				$id = get_first_from ($list); // if not, get it
			debug ("user id: $id");
			test ($id, alert_run (msg("not selected", "user")));
			if ($id != $_SESSION["user_id"]) {
				$ok = test ($user->check_my ("users"), alert_run (msg("no rights")));
				if (!$ok)
					return false;
			}
			$this->input = $users->get_one ("*", "WHERE id='$id'");
			info ($db->report ($users->get_error (), ""));
			test ($this->input, alert_run (msg("select fail")));

		} elseif ($section == "new") {

			###############################################################################
			# 'new' user
			
			// check rights
			test ($user->check_my ("users"), alert_run (msg("no rights")));
			// create auser["column"] structure
			// this is important : set id to "" -> module_user_edit uses this to recognize "new" user
			$this->input = array (
				"id" => "",		"blocked" => "0",
				"name" => "",	"username" => "",
				"email" => "",	"signature" => "",
				"ugroup" => "",	"page_size" => "25",
				"show_help" => "1",
				"language" => $config["lang"],
				"notify_issues" => "0",
				"notify_articles" => "0"
			);

		} else
			failexit ("wrong section");
		return true;
	}
	
    function custom_check () {
		global $user;
		//debug ("custom check");
		if (!$this->values ['Name'])
			$this->error ('Name', msg("form Name error"));
		// check this : only in admin mode
		if ($user->check_my ("users"))
			if (!$this->values ['Username'])
				$this->error ('Username', msg("form Username error"));
		if (isset ($this->values["Blocked"]) && $user->id == $this->values["Id"]) {
			unset ($this->values["Blocked"]);
			$this->error ("Blocked", msg("form Blocked error"));
		}
		if (!is_numeric ($this->values["Page_size"]) ||
			$this->values["Page_size"] < 5 ||
			$this->values["Page_size"] > 500) {
			$this->error ("Page_size", msg("form Page_size error"));
		}
	}
	
	function store_data () {
		global $user, $db, $DEFAULT_PASSWORD;
		//debug ("storing data");
		$show_help = isset ($this->values["Show_help"]) ? '1' : '0';
		$notify_i = isset ($this->values["Notify_issues"]) ? '1' : '0';
		$notify_a = isset ($this->values["Notify_articles"]) ? '1' : '0';
		
		// ** NORMAL user edit mode
		if ($user->check_my ("users") == false) {
			$db->exec ("UPDATE Users SET
				name='{$this->values["Name"]}',
				email='{$this->values["Email"]}',
				signature='{$this->values["Signature"]}',
				language='{$this->values["Language"]}',
				page_size='{$this->values["Page_size"]}',
				show_help='$show_help',
				notify_issues='$notify_i',
				notify_articles='$notify_a'
				WHERE id='{$this->values["Id"]}'", 1);
			info ($db->report (msg("update fail"), msg("saved")));
			$this->display_form ();
			return;
		}
		// ** ADMIN user edit mode
		// retranslate checkbox data to db format
		$blocked = isset ($this->values["Blocked"]) ? '1' : '0';
		if ($this->values["Id"] == "") {
			// this means we came from "new"
			// insert into DB
			$RS = $db->exec ("INSERT INTO Users
				(name, username, email, signature, password, blocked, ugroup, language, page_size, show_help, 
				 notify_issues, notify_articles)
				VALUES
				('{$this->values["Name"]}', '{$this->values["Username"]}',
				 '{$this->values["Email"]}', '{$this->values["Signature"]}',
				 '$DEFAULT_PASSWORD', '$blocked', '{$this->values["Group"]}',
				 '{$this->values["Language"]}', '{$this->values["Page_size"]}',
				 '$show_help', '$notify_i', '$notify_a')", 1);
			info ($db->report (msg("insert fail"), msg("saved")));
			if ($RS) {
				// get 'id' and move to edit
				$id = $db->last_insert_id ("users_id_seq");
				print "<SCRIPT>document.location.href='main.php?sec=edit&id=$id'</SCRIPT>\n";
			} else {
				// failed: if it's because of duplicate name:
				if ($db->errno() == "1062") {
					$this->error ('Name', msg("duplicate value"));
					$this->display_form ();
				}
			}
		} else {
			// this means just normal save in "edit"
			// update user in DB, don't change pass !
			$q = "UPDATE Users SET 
				name='{$this->values["Name"]}', 
				username='{$this->values["Username"]}',
				email='{$this->values["Email"]}',
				signature='{$this->values["Signature"]}',
				blocked='$blocked', ugroup='{$this->values["Group"]}',
				language='{$this->values["Language"]}',
				page_size='{$this->values["Page_size"]}',
				show_help='$show_help',
				notify_issues='$notify_i',
				notify_articles='$notify_a'
				WHERE id='{$this->values["Id"]}'";
			$db->exec ($q, 1);
			info ($db->report (msg("update fail"), msg("saved")));
			$this->display_form ();
		}
	}

    function display_form () {
		global $db, $user, $config;
		// ** switch NORMAL/ADMIN user edit mode
		$admin = $user->check_my ("users");
		$t = new form_hidden ($this, 'Id', $this->input["id"]);
		$t->display ();
?>
		<input type="hidden" name="id" value="<?= $this->input["id"]?>">
		<table class="form">
		<?	// *** Real name
			$t = new form_text ($this, 'Name', $this->input["name"], 'size="60"');
			$this->_display_item ($t);

			// *** Username
			$t = new form_text ($this, 'Username', $this->input["username"], 'size="60"');
			$this->_display_item ($t);

			// *** Email
			$t = new form_text ($this, 'Email', $this->input["email"], 'size="60"');
			$this->_display_item ($t);

			// *** Signature
			$t = new form_textarea ($this, 'Signature', $this->input["signature"], 'cols="50" rows="4"');
			$this->_display_item ($t);

			// *** Blocked
			$t = new form_checkbox ($this, 'Blocked', $this->input["blocked"]);
			$this->_display_item ($t);

			// *** User group
			// create group select box
			// groups in same order as in db, should be: ASC with more rights
			// note: directly from db, Ugroups don't have an instance of db_entity
			$db->exec ("SELECT id, name FROM Ugroups ORDER BY id");
			info ($db->report (msg ("select fail")));
			$options = array ();
			while ($row = $db->get_result ())
				$options[$row[0]] = $row[1];
			$t = new form_select ($this, 'Group', $options, $this->input["ugroup"]);
			if ($t->visible ()) :
		?>
			<tr><td><?	$t->description () ?></td>
				<td><?	$t->display ();
						$this->error_report ($t->name);	?></td>
			</tr>
		<?	endif;	?>
		</table>
		<!-- <hr size="1"> -->
		<table class="form">
		<?	// PREFERENCES
		
			// *** Language
			// create group select box
			$options = array ();
			foreach ($config["lang_list"] as $lang)
				$options[$lang] = $lang;
			$t = new form_select ($this, 'Language', $options, $this->input["language"]);
			if ($t->visible ()) :
		?>
			<tr><td><?	$t->description () ?></td>
				<td><?	$t->display ();
						$this->error_report ($t->name);	?></td>
			</tr>
		<?	endif;
		
			// *** Page size
			$t = new form_text ($this, 'Page_size', $this->input["page_size"], 'size="3"');
			$this->_display_item ($t);
		
			// *** Show help
			$t = new form_checkbox ($this, 'Show_help', $this->input["show_help"], 'class="checkbox"');
			$this->_display_item ($t);

			// *** Issue notifications
			$t = new form_checkbox ($this, 'Notify_issues', $this->input["notify_issues"], '');
			$this->_display_item ($t);

			// *** Article notification
			// if this user is an editor
			if ($user->check_my ("a_correct")) {
				$t = new form_checkbox ($this, 'Notify_articles', $this->input["notify_articles"], '');
				$this->_display_item ($t);
			}
		?>
		</table>
		</form>
<?	}

} // class

?>
