<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################
# article detail popup

	// includes
	require_once '../config.php';
	require_once INCLUDE_DIR .'/globals.php';

	// save page rendering start time 
	$time_start = getmicrotime ();

	require_once INCLUDE_DIR .'/db.php';
	require_once INCLUDE_DIR .'/classes.php';
	require_once INCLUDE_DIR .'/admin.php';

	// *** session check
	require_once INCLUDE_DIR .'/session_check.php';

	###############################################################################

	// create user object (for rights)
	//require_once INCLUDE_DIR ."/classes/class.user.php";
	$user = new user ($user_id);
	if (isset ($user->language))
		$config['lang'] = $user->language;

	// get client browser
	$browser = new browser_detection ();

// } GLOBAL ENVELOPE

// TODO: differentiate this (main for popups too?)
// we don't have msg() unless $main is created
	$main = new main ("_default", $user);

	// GUI START, MENU
	//
	
	$ASET_GLOBAL = new taset (array (
		"body" => 'onload="startclock('. $config["session_lifetime"] .",\n'".
			msg ("5 mins left") ."',\n'".
			msg ("1 min left") ."',\n'".
			msg ("0 min left") ."');\"",
		"menu.inactive" => 'class="inactive"',
		"menu.desc" => 'class="tinydesc"',
		), "warning"
	);

	$ASET_LIST = new taset (array (
		"table" => 'class="list" cellspacing="0" summary="item list"',
		"thead" => 'class="listhead"',
		"tr" => array ('class="listitems" bgcolor="white"', 'class="listitems" bgcolor="#e4e4e4"'),
		"tr.head" => 'class="listhead"',
		"td" => array ('width="20"', '', '', '', '', '', '', '', '', '', ''),
		"tr.foot" => '',
		"td.foot" => 'class="listfoot"',
		"a.button" => 'class="listbutton"',
		"a.button_number" => 'class="listbutton_number"',
		"a.button_current" => 'class="listbutton_current"',
		), "warning"
	);	// }

	// *** main: module management, 
	// constructor will set/get session variables & handle logout
	$main = new main ('_default', $user);

	// *** start gui
	$gui = new gui ($ASET_GLOBAL, $config['charset'], 'en', $config['project_name']);
	// TODO: msg ()
	$gui->title = 'Article System - article detail popup';
	$gui->author ($config['author']);
	$gui->style ('gui/css/detail.css');
	$gui->script ('js/help.js');
	$gui->script ('js/showdiv.js');
	$gui->begin ();

	// *** display title
	$id = $_GET['id'];
	$a = $articles->get_one ('*', "WHERE id='$id'");
?>
<div class="menu">
<table>
<tr><td>
	<?= msg('article detail') . q($a['title']) ?>
</td></tr>
</table>
</div>

<div id="main">
<form name="off" style="margin:0">

<table class="layout">
<tr><td valign="top">

	<table class="block" width="98%">
		<tr><td width="100" class="cn"><?= msg('column Id') ?></td>
			<td><?= $a['id'] ?></td>
		</tr>
		<tr><td class="cn"><?= msg('form Title') ?></td>
			<td><?= $a['title'] ?></td>
		</tr>
		<tr><td class="cn"><?= msg('form Subtitle') ?></td>
			<td><?= $a['subtitle'] ?></td>
		</tr>
		<tr><td class="cn"><?= msg('form MenuTitle') ?></td>
			<td><?= $a['menu_title'] ?></td>
		</tr>
		<tr><td class="cn"><?= msg('column Menu_group') ?></td>
			<td><?= $a['menu_group'] ?></td>
		</tr>
	</table>

</td><td valign="top">

	<table class="block">
		<tr><td width="120"><?
				echo msg('form Extras');
				$state = $a['display_extras'] ? ' checked' : '';
			?></td>
			<td width="30"><input type="checkbox"<?= $state ?> disabled></td>
		</tr>
		<tr><td class="cn"><?= msg('column Counter') ?></td>
			<td><?= $a['counter'] ?></td>
		</tr>
		<tr><td class="cn"><?= msg('column Rating') ?></td>
			<td><?= $a['rating'] ?></td>
		</tr>
		<tr><td class="cn"><?= msg('column Num_rated') ?></td>
			<td><?= $a['num_rated'] ?></td>
		</tr>
	</table>

</td></tr>
<tr><td colspan="2" valign="top">

	<table class="block" width="100%">
		<tr><td width="10%"><?= msg('form Author') ?></td>
			<td width="20%"><?
				$duser = $users->get_one ('name', "WHERE id='{$a['author']}'");
				echo $duser['name'];
			?></td>
			<td width="20%"><?= msg ('column Created_on') ?></td>
			<td width="5%"></td>
			<td><?= $a['created_on'] ?></td>
		</tr>
		<tr><td colspan="2">
			<td><?	echo msg ('column Author_done');
					$state = $a['author_done'] ? ' checked' : '';
			?></td>
			<td><input type="checkbox"<?= $state ?> disabled></td>
			<td><?= $a['finished_on'] ?></td>
		</tr>
		<tr><td><?= msg('column Editor') ?></td>
			<td><?	$duser = $users->get_one ('name', "WHERE id='{$a['editor']}'");
					echo $duser['name'];
			?></td>
			<td><?	echo msg ('column Author_done');
					$state = $a['editor_done'] ? ' checked' : '';
			?></td>
			<td><input type="checkbox"<?= $state ?> disabled></td>
			<td><?= $a['edited_on'] ?></td>
		</tr>
		<tr><td><?= msg('column Publisher') ?></td>
			<td><?	$duser = $users->get_one ('name', "WHERE id='{$a['publisher']}'");
					echo $duser['name'];
			?></td>
			<td><?	echo msg ('column Approved');
					$state = $a['approved'] ? ' checked' : '';
			?></td>
			<td><input type="checkbox"<?= $state ?> disabled></td>
			<td><?= $a['approved_on'] ?></td>
		</tr>
		<tr><td colspan="2">
			<td><?	echo msg ('column Published');
					$state = $a['published'] ? ' checked' : '';
			?></td>
			<td><input type="checkbox"<?= $state ?> disabled></td>
			<td><?= $a['published_on'] ?></td>
		</tr>
<?	if ($a['published']) :	?>
		<tr><td colspan="2"></td>
			<td colspan="3"><?
				if (is_numeric ($a['issue'])) {
					echo msg('published in issue');
					$dissue = $issues->get_one ('*', "WHERE id='{$a['issue']}'");
					echo q($dissue['name']);
				} else {
					echo msg('published in groups');
					$ags = $articles->get_all_groups ($a['id'], "G.id, G.name", "AND G.exported='1'");
					foreach ($ags as $dgroup)
						echo q ($dgroup['name']) .", ";
				}
			?></td>
		</tr>
<?	endif;	?>
	</table>
	
</td></tr>

<?	// *** hidden divs
	// ===============

	// *** Preview
	if (!empty ($a['preview'])) :	?>
<tr><td colspan="2" valign="top">

	<div><a href="javascript:show_div ('preview');" class=""><?
		echo msg ('form Preview');
		if ($user->show_help)
			echo ' ('. msg ('click to display') .')';
	?></a></div>
	<div id="preview" style="display: none;" class="block">
		<?= $a['preview'] ?>
	</div>
	
</td></tr>
<?	endif;

	// *** Content
	if (!empty ($a['content'])) :	?>
<tr><td colspan="2" valign="top">

	<div><a href="javascript:show_div ('content');"><?
		echo msg ('form Content');
		if ($user->show_help)
			echo ' ('. msg ('click to display') .')';
	?></a></div>
	<div id="content" style="display: none;" class="block">
		<?= $a['content'] ?>
	</div>
	
</td></tr>
<?	endif;

	// *** Sources
	if (!empty ($a['sources'])) :	?>
<tr><td colspan="2" valign="top">

	<div><a href="javascript:show_div ('sources');"><?
		echo msg ('form Sources');
		if ($user->show_help)
			echo '('. msg ('click to display') .')';
	?></a></div>
	<div id="sources" style="display: none;" class="block">
		<?= $a['sources'] ?>
	</div>
	
</td></tr>
<?	endif;

	// left hidden: keywords, signature

?>

</table>
</form>
</div>

<hr size="1" width="96%">
<div align="center">
	<a href="javascript:self.close()"><?= msg ('close') ?></a>
</div>

<?
	$gui->end();
?>
