<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################
# image browser / upload

	// includes
	require_once '../config.php';
	require_once INCLUDE_DIR .'/globals.php';

	require_once INCLUDE_DIR .'/db.php';
	require_once INCLUDE_DIR .'/classes.php';
	require_once INCLUDE_DIR .'/admin.php';

	// *** session check
	require_once INCLUDE_DIR .'/session_check.php';

	###############################################################################

	// create user object (for rights)
	//require_once INCLUDE_DIR ."/classes/class.user.php";
	$user = new user ($user_id);
	if (isset ($user->language))
		$config['lang'] = $user->language;

	// set some variables
	// images_state (uploads/articles)
	if (isset ($_GET['images_state'])) 
		$_SESSION['images_state'] = $_GET['images_state'];
	$state = isset ($_SESSION['images_state']) ? $_SESSION['images_state'] : '';
	// target form name
	if (isset ($_GET['images_form']))
		$_SESSION['images_form'] = $_GET['images_form'];
	$form = isset ($_SESSION['images_form']) ? $_SESSION['images_form'] : '';
	// target form item name
	if (isset ($_GET['images_item']))
		$_SESSION['images_item'] = $_GET['images_item'];
	$item = isset ($_SESSION['images_item']) ? $_SESSION['images_item'] : '';
	$urlbonus = "&images_form=$form&images_item=$item";

	// GUI START, MENU
	//

	// TODO: move somewhere else {
	$ASET_IMAGES = new taset (array (
		'body' => '',
		"menu.table" => 'class="menu"',
		"menu.a" => 'class="menu"',
		"menu.inactive" => 'class="inactive"',
		), 'warning'
	);
	
	$ASET_LIST = new taset (array (
		"table" => 'class="list" cellspacing="0" summary="item list"',
		"thead" => 'class="listhead"',
		"tr" => array ('class="listitems" bgcolor="white"', 'class="listitems" bgcolor="#e4e4e4"'),
		"tr.head" => 'class="listhead"',
		"td" => array ('width="20"', '', '', '', '', '', '', '', '', '', ''),
		"tr.foot" => '',
		"td.foot" => 'class="listfoot"',
		"a.button" => 'class="listbutton"',
		"a.button_number" => 'class="listbutton_number"',
		"a.button_current" => 'class="listbutton_current"',
		// image controls
		// TODO: align=center, width browser dependent (IE:120, MOZ:130, ..??)
		"td.image_controls" => 'width="130"',
		//"input.image_controls" => array (
		//	'class="image_controls" style="background-color: white"',
		//	'class="image_controls" style="background-color: #e4e4e4"'),
		"input.image_controls" => 'class="image_controls" style="background-color: white"',
		// image code
//		"input.img_code" => 'class="image_controls_code" size="75"',
		"input.img_code" => 'class="image_controls_code" size="75"',
		"table.img_code" => 'class="list" bgcolor="#e4e4e4" cellpadding="4" cellspacing="0" summary="item list"',
		"tr.img_code" => 'class="listitems" bgcolor="#e4e4e4"',
		"td.img_code" => 'class="listitems" bgcolor="#e4e4e4"',
		"td.img_code_buttons" => 'align="right" class="listitems" bgcolor="#e4e4e4"',
        // image upload
		"input.img_upload" => 'class="image_controls_upload"',

		), "warning"
	);	// }

	// *** main: module management, 
	// constructor will set/get session variables & handle logout
	$main = new main ('_default', $user);

	// *** start gui
	$gui = new gui ($ASET_IMAGES, $config['charset'], 'en', $config['project_name']);
	$gui->title = 'Article System - image browser/upload';
	$gui->author ($config['author']);
	$gui->style ('gui/css/images.css');
	$gui->script ('js/help.js');
	$gui->begin ();

	// *** display main menu ... published / uploaded images switch
?>
<div class="menu">
<table>
<tr><td width="30%">
	<?= msg('images list') ?>
</td><td width="30%">
<?
	if ($state == "uploads") {
		echo "<a href=\"?images_state=aimages".$urlbonus."\" title=\"" .msg('images published 1'). "\">" .
			msg('images published 2'). "</a> ";
		echo "</td><td width=\"30%\">";
		echo msg('images uploaded 2');
	} else {
		echo msg('images published 2');
		echo "</td><td width=\"30%\">";
		echo " <a href=\"?images_state=uploads".$urlbonus."\" title=\"" .msg('images uploaded 1'). "\">" .
			msg('images uploaded 2'). "</a>";
	}

?>
</td></tr>
</table>
</div>
<?
	// *** images main document
	$gui->images_begin ();

	// this must be here everytime (even empty)
?>
	<div class="list">
	<form name="item_list" method="post" style="margin:0">
<?

	// IMAGE BROWSER
	//
	$dr = new data_retriever_db_images ();
	if ($state == 'uploads') {
		$dr->prepare ($images, 'WHERE uploaded=1 ORDER BY filename');
	} else {
		$dr->prepare ($images, 'WHERE uploaded=0 ORDER BY filename');
	}
	$ibrowser = new image_browser (
		$dr->format_array_2D(),
		new tag_writer_taset ($ASET_LIST),
		$images);
	$ibrowser->use_usebutton ($form, $item);
	$ibrowser->use_header (array ('', msg('images file name'), msg('images image info'), msg('images actions')));
	$ibrowser->use_checkboxes (array (0), 'F');
	$ibrowser->page_controls ();
	$ibrowser->display ();

?>
	</form>
	</div>

	<div>
<?

	// UPLOAD BOX
	//
	if ($state == 'uploads') {
		$upload = new upload_tw ($config['upload_dir'], new tag_writer_taset ($ASET_LIST), 500);
		$upload->set_check_extension (array ('gif', 'jpeg', 'jpg', 'png'));
		$upload->set_check_type (array ('image/gif', 'image/pjpeg', 'image/jpeg', 'image/png'));
		if (!$user->check_my ('a_publish'))
			$upload->set_check_imgsize (400, 400);
		$upload->insert_form ('?images=uploads', 'img_upload', msg('upload send'));
		// TODO: $upload->errors override ... with msg()s

		$ret = $upload->get_file ();
		if ($ret == "ok") {
			// upload ok : insert to db
			$filename = $upload->get_filename ();
			if ($images->is_unique ($filename)) {
				if ($images->insert_uploaded ($filename, $user_id)) {
					// force size read and reload form
					$images->get_size ($db->last_insert_id ("images_id_seq"));
					print "<SCRIPT>document.location.href='images.php?images=uploads';</SCRIPT>\n";
				} else
					unlink ($config['upload_dir'].'/'.$filename);
			} else {
				echo '<p class="error">'. msg('upload not unique'). '</p>';
				unlink ($config['upload_dir'].'/'.$filename);
			}
		}
		if ($upload->get_error ()) {
			echo '<p class="error">';
			$upload->error_report ();
			// TODO: info about expected params when failed
			echo '</p>';
		}

	}
?>
	</div>
<?
	$gui->images_end ();
	$gui->end();
?>
