<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################
# main screen of the administrations pages

	// some includes
	require_once '../config.php';
	require_once INCLUDE_DIR .'/globals.php';
	
	// save page rendering start time 
	$time_start = getmicrotime ();
	
	require_once INCLUDE_DIR .'/db.php';
	require_once INCLUDE_DIR .'/classes.php';
	require_once INCLUDE_DIR .'/admin.php';

	// *** session check
	require_once INCLUDE_DIR .'/session_check.php';

	###############################################################################

	// create user object (access rights)
	$user = new user ($user_id);
	if (isset ($user->language))
		$config['lang'] = $user->language;
	
	// get client browser
	$browser = new browser_detection ();
		
//	$user->rights["a_correct"] = 0;
//	$user->rights["a_approve"] = 0;
//	$user->rights["users"] = 0;
//	adebug ($user->rights);
	
	// main: module management, 
	// set up session variables
		// NOTE: reference global variables cannot be set in a not global scope
		// (global $var is a reference itself!)
	if (!isset ($_SESSION['module']))
		$_SESSION['module'] = '';
	if (!isset ($_SESSION['section']))
		$_SESSION['section'] = '';
	$module	=& $_SESSION['module'];
	$section =& $_SESSION['section'];
	// constructor will update session variables & handle logout
	$main = new main ('_default', $user);
	$title = $main->get_title ();

	// global taset
	$ASET_GLOBAL = new taset (array (
		"body" => 'onload="startclock('. $config["session_lifetime"] .",\n'".
			msg ("5 mins left") ."',\n'".
			msg ("1 min left") ."',\n'".
			msg ("0 min left") ."');\"",
		"menu.inactive" => 'class="inactive"',
		"menu.desc" => 'class="tinydesc"',
		), "warning"
	);

	// list table taset
	$ASET_LIST = new taset (array (
		"table" => 'class="list" cellspacing="0" summary="item list"',
		"thead" => 'class="listhead"',
		"tr" => array ('class="listitems" bgcolor="white"', 'class="listitems" bgcolor="#e4e4e4"'),
		"tr.head" => 'class="listhead"',
		"td" => array ('width="20"', '', '', '', '', '', '', '', '', '', ''),
		"tr.foot" => '',
		"td.foot" => 'class="listfoot"',
		"a.button" => 'class="listbutton"',
		"a.button_number" => 'class="listbutton_number"',
		"a.button_current" => 'class="listbutton_current"',
		// buttons:
		"input.image_controls" => 'class="image_controls"',
		), "warning"
	);
	
	// *** start gui
	$gui = new gui ($ASET_GLOBAL, $config['charset'], 'en', $config['project_name']);
	$gui->title = $title;
	$gui->author ($config['author']);
	$gui->created (datetime ());
	$gui->keywords ("{$config["project_name"]}, Article System, artsys");
	$gui->style ('gui/css/style.css');
	foreach ($main->scripts as $script)
		$gui->script ($script);

	$gui->begin ();

	// *** display main menu ...
		$gui->main_menu_begin ();
		// first row is generated by main class
		$main->menu_modules ();
		$active_module = $main->get_active ();
		if (!$active_module)
			exit;
		// while the second by the active module
		$active_module->menu_sections ();
		// display login info and friends
		$main->menu_info ();
		// this is about everything to the menu
		$gui->main_menu_end ();
	
	// *** get include filename
		$include_file = $active_module->get_include ();

	// *** deploy scripts
		foreach ($main->inline_scripts as $script)
			$gui->script_inline ($script);
		foreach ($active_module->scripts as $script)
			$gui->script_inline ($script);
		
	// *** prepare main inclusion
		$gui->main_begin ();
	// *** help
		$gui->display_help ($main->get_help (), $user->show_help);
	// *** include (module, section) corresponding file
	// *** and finalize page rendering
		require_once ($include_file);
		$active_module->create_form ();
		// get page rendering end time 
		$time = getmicrotime () - $time_start;
		echo "\n\n<span class=\"invisible\">page rendering time: $time seconds\n";
		if (function_exists ("memory_get_usage"))
			echo "<br>memory usage: ". memory_get_usage () ." bytes</span>\n";
		$gui->main_end ();	
		
	// finish off gui :-)
	$gui->end ();
?>
