<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################
# TEMPLATE WEBSITE
#

	// read config
	require_once '../public/config.php';
	require_once INCLUDE_DIR .'/globals.php';
	require_once INCLUDE_DIR .'/db.php';

	// fake client msg()
	function msg ($text) {
		echo "<pre>system message: $text</pre>";
	}

	// GLOBALS
	// number of issues displayed on the left menubar
	$ISSUES_IN_MENU = 6;

	// background color
	$BGCOLOR = '#140865';

	// default page to display (index / main)
	// FIXME: may become obsolete - newest issue main page displayed by default
	$PAGE_DEFAULT = 'article.php';

	// list of pages of this site
	$PAGE_LIST = array (
		'main'			=>	$PAGE_DEFAULT,
		'releases'		=>	'releases.php',
		'archive'		=>	'archive.php',
		'issue'			=>	'issue.php',
		'volume'		=>	'volume.php',
		'article'		=>	'article.php',
		'group'			=>	'group.php',
		'search'		=>	'search.php',
		'artsys'		=>	'artsys.php',
		'sites'			=>	'sites.php',
		'comments'		=>	'comments.php',
	);

	// fail function
	function fail ($message) {
		global $client;
   		echo '<p><span style="color:red">Failure:</span> '. $message .'<br>';
		// not used since created
		//echo 'Last client error: '. $client->error .'</p>';
  	}

	// check possible login, create session and redirect
	require_once (INCLUDE_DIR .'/session_create.php');

// manual continuation of 'session_create'
if (!isset ($login)) {

	###############################################################################
	# client setup
	#

	// set up client object (+db connection)
	require_once INCLUDE_DIR .'/client.php';
	$client = new client ($articles, $agroups, $issues, $images, $users);

	// create user object (for rights)
	//$user =& new user ($user_id);

	// get CURRENT issue
	$CURRENT_ISSUE = $client->issues->get ();
	if (!$CURRENT_ISSUE) {
		info ("There are no issues active in the system.<br> Login to the administration part at
			<a href=\"{$config['base_admin_url']}\">{$config['base_admin_url']}</a> to create
			and publish a new issue.<br>
			See online howtos for help.");
		exit;
	}
}


	###############################################################################
	# template : data preparation
	#

	// *** version
	$VERSION = VERSION;

	// *** menu articles
	$menu = $client->agroups->get_by ('name', 'menu');
	$menu_articles = $client->agroups->get_articles ($menu['id']);
	// first two articles in the menu
	$MENU_ARTICLES_BEFORE = array_slice ($menu_articles, 0, 2);
	// last articles in the menu
	$MENU_ARTICLES_AFTER = array_slice ($menu_articles, 2);
	
	// *** latest issues, ordered DESC by publish date
	$ARCHIVE = $client->issues->get_archive ('ORDER BY published_on DESC');
	if (count ($ARCHIVE) > $ISSUES_IN_MENU-1)
		$ARCHIVE = array_slice ($ARCHIVE, 0, $ISSUES_IN_MENU-1);

	// *** best rated articles
	$RATED_ARTICLES = $client->articles->get_by_rating (3);
	$DISPLAY_RATED_ARTICLES = empty ($RATED_ARTICLES) ? false : true;
	for ($i=0; $i < count ($RATED_ARTICLES); $i++)
		$RATED_ARTICLES[$i]['rating'] = round ($RATED_ARTICLES[$i]['rating'], 1);
	
	// *** moset read articles
	$MOST_READ_ARTICLES = $client->articles->get_by_counter (3);
	// to display only articles from issues:
	//$MOST_READ_ARTICLES = $client->articles->get_by_counter (3, "id, title, counter", "WHERE A.issue IS NOT NULL");
	$DISPLAY_MOST_READ = empty ($MOST_READ_ARTICLES) ? false : true;

	// *** registered page
	$req =& $_GET['req'];
	//debug ("request: $req");
	if (!$req || !in_array ($req, array_keys ($PAGE_LIST))) {
		//debug ("including default: $PAGE_DEFAULT");
		$REQUIRED_PAGE = $PAGE_DEFAULT;
	} else {
		//debug ("including: $PAGE_LIST[$req]");
		$REQUIRED_PAGE = $PAGE_LIST[$req];
	}
	

	###############################################################################
	# template : include
	#
	
	// TODO: more versions may be added (Strict HTML/XML)
	if (DEBUG_LEVEL == 'MLOG_ALL' || DEBUG_LEVEL == 'MLOG_MASSIVE')
		echo ("<!-- template: {$config['template']} -->\n");
	require "{$config['public_dir']}/templates/{$config['template']}/index.php";

	if ($config['template'] == 'smarty') {
		require "{$config['public_dir']}/$REQUIRED_PAGE";
		$smarty->display('index.tpl');
	}
	
?>
