<?php

/*
 *	Article System
 *	Online journal management tool written in PHP/MySQL/PostgreSQL.
 *	This code is available at http://sourceforge.net/projects/artsys
 *
 *	Copyright (C) 2001-2005 Jan Hnatek
 *	Distributed under the terms of the GNU General Public License
 *
 *	Date:	  05/08/2005
 *	Version:  0.6   	
 */

###############################################################################
# TEMPLATE WEBSITE
#

	require_once INCLUDE_DIR ."/forms.php";
	require_once INCLUDE_DIR ."/classes/class.fulltext_index.php";

	// get form data
	$first = true;
	$words = isset ($_POST['words']) ? $first = $_POST['words'] : '';
	$group = isset ($_POST['group']) ? $first = $_POST['group'] : '';
	$author = isset ($_POST['author']) ? $first = $_POST['author'] : '';
	$issue = isset ($_POST['issue']) ? $first = $_POST['issue'] : '';
	
	$exact = false;
	$case_sensitive = false;

	// *** group selectbox
	// FIXME: locale ?? / use client class !!
	function GROUP_SELECT_BOX () {
		global $agroups, $group;
		$agroups->get ('id, menu_text', "WHERE exported='1' ORDER BY name");
		if ($agroups->error_report () == false)
			$agroups->select_box (
				// name, col_values, col_texts, selected,
				'group', 'id', 'menu_text', $group,
				// begin_values, end_values, attributes
				array ('' => '-----------'), '', ''
			);
	}

	// *** author selectbox
	function AUTHOR_SELECT_BOX () {
		global $client, $author;
		$client->users->get_publishing ();
		// FIXME: no error checking ?
		//if ($client->users->error_report () == false)
			$client->users->select_box (
				// name, col_values, col_texts, selected,
				'author', 'id', 'name', $author,
				// begin_values, end_values, attributes
				array ('' => '-----------'), '', ''
			);
	}

	// *** issue selectbox
	function ISSUE_SELECT_BOX () {
		global $issues, $issue;
		// FIXME: use client class !!
		$issues->get ('id, name', 'ORDER BY published_on');
		if ($issues->error_report () == false)
			$issues->select_box (
				// name, col_values, col_texts, selected,
				'issue', 'id', 'name', $issue,
				// begin_values, end_values, attributes
				array ('' => '-----------'), '', ''
			); 
	}
	
	// *** search results
	$indexed =& $db->array_exec ("SELECT object_id FROM object_word_link GROUP BY object_id");
	//echo "total indexed articles: ", count ($tmp), "<br>\n";
	$DISPLAY = '';
	$NO_INDEX = false;
	$NO_MATCHING_ARTICLES = false;

	if (empty ($indexed)) {
		$NO_INDEX = true;
	} else {
	
		function array_rewrite ($array, $eval_code) {
			$ret = array ();
			foreach ($array as $temp)
				eval ("array_push (\$ret, $eval_code);");
			return $ret;
		}
		
		// default: trigger to begin merging search results
		$results = "new";
		
		// get articles matching search parameters and merge them
		if (!empty ($words)) {
			// TODO: second param as array (list of columns) ?
			$s =& new fulltext_index ('Articles', 'content');
			$results = $s->find ($words, $exact, $case_sensitive);
		}
		if (!empty ($group)) {
			$tmp =& $client->agroups->get_articles ($group);
			$results = ($results == 'new') ?
				array_rewrite ($tmp, "\$temp['id']") :
				array_intersect ($results, array_rewrite ($tmp, "\$temp['id']"));
		}
		if (!empty ($author)) {
			$tmp =& $client->users->get_articles ($author);
			$results = ($results == 'new') ?
				array_rewrite ($tmp, "\$temp['id']") :
				array_intersect ($results, array_rewrite ($tmp, "\$temp['id']"));
		}
		if (!empty ($issue)) {
			$tmp =& $client->issues->get_articles ($issue);
			$results = ($results == 'new') ?
				array_rewrite ($tmp, "\$temp['id']") :
				array_intersect ($results, array_rewrite ($tmp, "\$temp['id']"));
		}
		//adebug ($results);
		
		// display results
		if (!empty ($results) && $results != 'new') {
			for ($i=0, reset ($results); list ($idx, $aid) = each ($results); $i++) {
				$a = $client->articles->get ($aid);
				$DISPLAY .= ($i+1) .": &nbsp; <a href=\"?req=article&id={$a['id']}\">{$a['title']}</a><br>";
				//echo "<a href=\"?req=article&id=", $a["id"], "\">", $a["title"], "</a><br>";
				// TODO: no preview, detailed information
				// like issue, groups, whatever
				if (!empty ($a['preview']))
					$DISPLAY .= "\n<blockquote>\n{$a['preview']}\n</blockquote>";
			}	
			
		} elseif ($first !== true) {
			$NO_MATCHING_ARTICLES = true;
		}

	} // $indexed

	
	###############################################################################
	# template : include
	#

	require "{$config['public_dir']}/templates/{$config['template']}/search.php";
?>
