------------------------------------------------------------------
-- My2Pg 1.28 translated dump
--
------------------------------------------------------------------






--
-- Sequences for table ACOMMENTS
--

CREATE SEQUENCE acomments_id_seq;

-- MySQL dump 9.11
--
-- Host: localhost    Database: artsysdb
-- ------------------------------------------------------
-- Server version	4.0.22-log

--
-- Table structure for table `Acomments`
--

DROP TABLE Acomments;
CREATE TABLE Acomments (
  id INT4 DEFAULT nextval('acomments_id_seq'),
  article INT4 NOT NULL DEFAULT '0',
  reply_to INT4 DEFAULT NULL,
  author varchar(100) DEFAULT NULL,
  email varchar(100) DEFAULT NULL,
  www varchar(100) DEFAULT NULL,
  subject varchar(255) DEFAULT NULL,
  content TEXT DEFAULT '' NOT NULL,
  time TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00',
  PRIMARY KEY (id)

);

--
-- Dumping data for table `Acomments`
--


--
-- Table structure for table `Agroups`
--

DROP TABLE Agroups;


--
-- Sequences for table AGROUPS
--

CREATE SEQUENCE agroups_id_seq;

CREATE TABLE Agroups (
  id INT4 DEFAULT nextval('agroups_id_seq'),
  parent INT4 DEFAULT NULL,
  gorder INT4 NOT NULL DEFAULT '0',
  name varchar(255) NOT NULL DEFAULT '',
  menu_text varchar(255) DEFAULT NULL,
  description varchar(255) DEFAULT NULL,
  intro text,
  inline INT2 NOT NULL DEFAULT '0',
  exported INT2 NOT NULL DEFAULT '0',
  PRIMARY KEY (id)

);

--
-- Dumping data for table `Agroups`
--

INSERT INTO Agroups VALUES (1,NULL,0,'domains','domains','Top-level group - domain list','',0,1);
INSERT INTO Agroups VALUES (6,1,2,'menu','Menu','site navigation','',0,1);

--
-- Table structure for table `Ainsertion`
--

DROP TABLE Ainsertion;


--
-- Sequences for table AINSERTION
--

CREATE SEQUENCE ainsertion_id_seq;

CREATE TABLE Ainsertion (
  id INT4 DEFAULT nextval('ainsertion_id_seq'),
  article INT4 NOT NULL DEFAULT '0',
  agroup INT4 NOT NULL DEFAULT '0',
  aorder INT4 NOT NULL DEFAULT '1',
  PRIMARY KEY (id)

);

--
-- Dumping data for table `Ainsertion`
--


--
-- Table structure for table `Arelated`
--

DROP TABLE Arelated;
CREATE TABLE Arelated (
  this INT4 NOT NULL DEFAULT '0',
  that INT4 NOT NULL DEFAULT '0'
);

--
-- Dumping data for table `Arelated`
--


--
-- Table structure for table `Articles`
--

DROP TABLE Articles;


--
-- Sequences for table ARTICLES
--

CREATE SEQUENCE articles_id_seq;

CREATE TABLE Articles (
  id INT4 DEFAULT nextval('articles_id_seq'),
  title TEXT DEFAULT '' NOT NULL,
  subtitle text,
  preview text,
  content TEXT DEFAULT '' NOT NULL,
  keywords varchar(255) DEFAULT NULL,
  sources text,
  counter INT4 DEFAULT '0',
  rating FLOAT8 DEFAULT '0',
  num_rated INT4 DEFAULT '0',
  display_extras INT2 DEFAULT '1',
  author INT4 NOT NULL DEFAULT '1',
  editor INT4 DEFAULT '1',
  publisher INT4 DEFAULT '1',
  signature varchar(255) NOT NULL DEFAULT '',
  author_done INT2 NOT NULL DEFAULT '0',
  editor_done INT2 NOT NULL DEFAULT '0',
  approved INT2 NOT NULL DEFAULT '0',
  published INT2 NOT NULL DEFAULT '0',
  created_on TIMESTAMP DEFAULT NULL,
  finished_on TIMESTAMP DEFAULT NULL,
  edited_on TIMESTAMP DEFAULT NULL,
  approved_on TIMESTAMP DEFAULT NULL,
  published_on TIMESTAMP DEFAULT NULL,
  issue INT4 DEFAULT NULL,
  menu_title varchar(100) NOT NULL DEFAULT '',
  igroup INT4 DEFAULT NULL,
  menu_group varchar(255) NOT NULL DEFAULT '',
  iorder INT4 NOT NULL DEFAULT '0',
  PRIMARY KEY (id)

);

--
-- Dumping data for table `Articles`
--


--
-- Table structure for table `Images`
--

DROP TABLE Images;


--
-- Sequences for table IMAGES
--

CREATE SEQUENCE images_id_seq;

CREATE TABLE Images (
  id INT4 DEFAULT nextval('images_id_seq'),
  filename varchar(100) NOT NULL DEFAULT '',
  owner INT4 NOT NULL DEFAULT '0',
  href varchar(255) DEFAULT NULL,
  description text,
  uploaded INT2 DEFAULT '0',
  published INT2 DEFAULT '0',
  filesize INT4 DEFAULT NULL,
  filetype INT4 DEFAULT NULL,
  width INT4 DEFAULT NULL,
  height INT4 DEFAULT NULL,
  PRIMARY KEY (id)

);

--
-- Dumping data for table `Images`
--

INSERT INTO Images VALUES (1,'artsys.gif',1,'http://artsys.sourceforge.net/','',0,1,NULL,NULL,NULL,NULL);

--
-- Table structure for table `Issues`
--

DROP TABLE Issues;


--
-- Sequences for table ISSUES
--

CREATE SEQUENCE issues_id_seq;

CREATE TABLE Issues (
  id INT4 DEFAULT nextval('issues_id_seq'),
  name varchar(100) NOT NULL DEFAULT '',
  menu_title varchar(100) NOT NULL DEFAULT '',
  subtitle varchar(100) DEFAULT NULL,
  volume INT4 DEFAULT NULL,
  current INT2 DEFAULT '0',
  archived INT2 DEFAULT '0',
  published_on TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00',
  PRIMARY KEY (id)

);

--
-- Dumping data for table `Issues`
--


--
-- Table structure for table `Iusage`
--

DROP TABLE Iusage;


--
-- Sequences for table IUSAGE
--

CREATE SEQUENCE iusage_id_seq;

CREATE TABLE Iusage (
  id INT4 DEFAULT nextval('iusage_id_seq'),
  article_id INT4 DEFAULT NULL,
  issue_id INT4 DEFAULT NULL,
  agroup_id INT4 DEFAULT NULL,
  user_id INT4 DEFAULT NULL,
  image INT4 NOT NULL DEFAULT '0',
  ident varchar(100) NOT NULL DEFAULT '',
  options varchar(255) DEFAULT NULL,
  PRIMARY KEY (id)

);

--
-- Dumping data for table `Iusage`
--


--
-- Table structure for table `Maillist`
--

DROP TABLE Maillist;


--
-- Sequences for table MAILLIST
--

CREATE SEQUENCE maillist_id_seq;

CREATE TABLE Maillist (
  id INT4 DEFAULT nextval('maillist_id_seq'),
  email varchar(255) NOT NULL DEFAULT '',
  name varchar(255) DEFAULT NULL,
  blocked INT2 NOT NULL DEFAULT '0',
  PRIMARY KEY (id)

);

--
-- Dumping data for table `Maillist`
--


--
-- Table structure for table `Sessions`
--

DROP TABLE Sessions;
CREATE TABLE Sessions (
  id varchar(64) NOT NULL DEFAULT '0',
  userid INT4 DEFAULT NULL,
  username varchar(255) NOT NULL DEFAULT '',
  ip varchar(255) NOT NULL DEFAULT '',
  time INT4 DEFAULT NULL,
  PRIMARY KEY (id)

);

--
-- Dumping data for table `Sessions`
--


--
-- Table structure for table `Stats_unique`
--

DROP TABLE Stats_unique;
CREATE TABLE Stats_unique (
  article INT4 NOT NULL DEFAULT '0',
  ip varchar(255) NOT NULL DEFAULT '',
  nat_client varchar(255) DEFAULT NULL,
  host varchar(255) DEFAULT NULL,
  user_agent INT4 NOT NULL DEFAULT '0',
  time INT4 NOT NULL DEFAULT '0',
  rating INT2 DEFAULT '0',
  PRIMARY KEY (article,ip,user_agent)

);

--
-- Dumping data for table `Stats_unique`
--


--
-- Table structure for table `Stats_user_agent`
--

DROP TABLE Stats_user_agent;


--
-- Sequences for table STATS_USER_AGENT
--

CREATE SEQUENCE stats_user_agent_id_seq;

CREATE TABLE Stats_user_agent (
  id INT4 DEFAULT nextval('stats_user_agent_id_seq'),
  text varchar(255) NOT NULL DEFAULT '',
  quantity INT4 DEFAULT '0',
  PRIMARY KEY (id)

);

--
-- Dumping data for table `Stats_user_agent`
--


--
-- Table structure for table `Ugroups`
--

DROP TABLE Ugroups;


--
-- Sequences for table UGROUPS
--

CREATE SEQUENCE ugroups_id_seq;

CREATE TABLE Ugroups (
  id INT4 DEFAULT nextval('ugroups_id_seq'),
  name varchar(255) NOT NULL DEFAULT '',
  a_read INT2 NOT NULL DEFAULT '0',
  a_create INT2 NOT NULL DEFAULT '0',
  a_correct INT2 NOT NULL DEFAULT '0',
  a_approve INT2 NOT NULL DEFAULT '0',
  issues INT2 NOT NULL DEFAULT '0',
  users INT2 NOT NULL DEFAULT '0',
  agroups INT2 NOT NULL DEFAULT '0',
  admin INT2 NOT NULL DEFAULT '0',
  PRIMARY KEY (id)

);

--
-- Dumping data for table `Ugroups`
--

INSERT INTO Ugroups VALUES (1,'authors',1,1,0,0,0,0,0,0);
INSERT INTO Ugroups VALUES (2,'editors',1,1,1,0,0,0,0,0);
INSERT INTO Ugroups VALUES (3,'publishers',1,1,1,1,1,0,1,0);
INSERT INTO Ugroups VALUES (4,'admins',1,1,1,1,1,1,1,1);

--
-- Table structure for table `Users`
--

DROP TABLE Users;


--
-- Sequences for table USERS
--

CREATE SEQUENCE users_id_seq;

CREATE TABLE Users (
  id INT4 DEFAULT nextval('users_id_seq'),
  name varchar(255) NOT NULL DEFAULT '',
  username varchar(255) NOT NULL DEFAULT '',
  email varchar(255) DEFAULT NULL,
  signature varchar(255) DEFAULT NULL,
  password varchar(255) NOT NULL DEFAULT '',
  blocked INT2 NOT NULL DEFAULT '0',
  ugroup INT4 NOT NULL DEFAULT '6',
  language varchar(10) NOT NULL DEFAULT 'en',
  show_help INT2 NOT NULL DEFAULT '1',
  page_size INT4 NOT NULL DEFAULT '20',
  notify_issues INT2 NOT NULL DEFAULT '0',
  notify_articles INT2 NOT NULL DEFAULT '0',
  PRIMARY KEY (id)

);

--
-- Dumping data for table `Users`
--

INSERT INTO Users VALUES (1,'administrator','root','root@artsys','','d5fdd4f1765bcf3e9d19f42e8ac11066',0,4,'en',1,25,0,0);

--
-- Table structure for table `Volumes`
--

DROP TABLE Volumes;


--
-- Sequences for table VOLUMES
--

CREATE SEQUENCE volumes_id_seq;

CREATE TABLE Volumes (
  id INT4 DEFAULT nextval('volumes_id_seq'),
  name varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (id)

);

--
-- Dumping data for table `Volumes`
--




--
-- Indexes for table VOLUMES
--

CREATE UNIQUE INDEX name_Volumes_index ON Volumes (name);
CREATE UNIQUE INDEX IDX_Volumes_id_Volumes_index ON Volumes (id);
CREATE UNIQUE INDEX IDX_Volumes_name_Volumes_index ON Volumes (name);

--
-- Indexes for table IUSAGE
--

CREATE UNIQUE INDEX ISX_Iusage_id_Iusage_index ON Iusage (id);
CREATE UNIQUE INDEX article_id_Iusage_index ON Iusage (article_id,issue_id,agroup_id,user_id,image);

--
-- Indexes for table ISSUES
--

CREATE UNIQUE INDEX name_Issues_index ON Issues (name);
CREATE UNIQUE INDEX IDX_Issues_id_Issues_index ON Issues (id);
CREATE UNIQUE INDEX IDX_Issues_name_Issues_index ON Issues (name);

--
-- Indexes for table USERS
--

CREATE UNIQUE INDEX username_Users_index ON Users (username);
CREATE UNIQUE INDEX IDX_Users_id_Users_index ON Users (id);
CREATE UNIQUE INDEX IDX_Users_username_Users_index ON Users (username);

--
-- Indexes for table AINSERTION
--

CREATE UNIQUE INDEX article_Ainsertion_index ON Ainsertion (article,agroup,aorder);
CREATE UNIQUE INDEX IDX_Ainsertion_id_Ainsertion_index ON Ainsertion (id);

--
-- Indexes for table SESSIONS
--

CREATE UNIQUE INDEX IDX_Sessions_id_Sessions_index ON Sessions (id);

--
-- Indexes for table MAILLIST
--

CREATE UNIQUE INDEX IDX_Maillist_id_Maillist_index ON Maillist (id);

--
-- Indexes for table ACOMMENTS
--

CREATE UNIQUE INDEX IDX_Acomments_id_Acomments_index ON Acomments (id);

--
-- Indexes for table STATS_USER_AGENT
--

CREATE UNIQUE INDEX text_Stats_user_agent_index ON Stats_user_agent (text);
CREATE UNIQUE INDEX IDX_Stats_user_agent_id_Stats_user_agent_index ON Stats_user_agent (id);

--
-- Indexes for table ARELATED
--

CREATE UNIQUE INDEX this_Arelated_index ON Arelated (this,that);
CREATE UNIQUE INDEX IDX_Arelated_this_that_Arelated_index ON Arelated (this,that);

--
-- Indexes for table UGROUPS
--

CREATE UNIQUE INDEX name_Ugroups_index ON Ugroups (name);
CREATE UNIQUE INDEX IDX_Ugroups_id_Ugroups_index ON Ugroups (id);
CREATE UNIQUE INDEX IDX_Ugroups_name_Ugroups_index ON Ugroups (name);

--
-- Indexes for table AGROUPS
--

CREATE UNIQUE INDEX IDX_Agroup_id_Agroups_index ON Agroups (id);
CREATE UNIQUE INDEX name_Agroups_index ON Agroups (name,parent);

--
-- Indexes for table ARTICLES
--

CREATE UNIQUE INDEX IDX_Articles_id_Articles_index ON Articles (id);

--
-- Indexes for table IMAGES
--

CREATE UNIQUE INDEX filename_Images_index ON Images (filename);
CREATE UNIQUE INDEX IDX_Images_id_Images_index ON Images (id);
CREATE UNIQUE INDEX IDX_Images_name_Images_index ON Images (filename);

--
-- Sequences for table VOLUMES
--

SELECT SETVAL('volumes_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from Volumes));

--
-- Sequences for table IUSAGE
--

SELECT SETVAL('iusage_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from Iusage));

--
-- Sequences for table ISSUES
--

SELECT SETVAL('issues_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from Issues));

--
-- Sequences for table USERS
--

SELECT SETVAL('users_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from Users));

--
-- Sequences for table AINSERTION
--

SELECT SETVAL('ainsertion_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from Ainsertion));

--
-- Sequences for table MAILLIST
--

SELECT SETVAL('maillist_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from Maillist));

--
-- Sequences for table ACOMMENTS
--

SELECT SETVAL('acomments_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from Acomments));

--
-- Sequences for table STATS_USER_AGENT
--

SELECT SETVAL('stats_user_agent_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from Stats_user_agent));

--
-- Sequences for table UGROUPS
--

SELECT SETVAL('ugroups_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from Ugroups));

--
-- Sequences for table AGROUPS
--

SELECT SETVAL('agroups_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from Agroups));

--
-- Sequences for table ARTICLES
--

SELECT SETVAL('articles_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from Articles));

--
-- Sequences for table IMAGES
--

SELECT SETVAL('images_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from Images));


