--
--	update MySQL artsys db: 0.3b -> 0.5b
--	Note: please take this just as a hint how to make the transformation,
--		make sure to dump the old contents before making any changes
--

	drop table ITables;

	alter table Articles add display_extras tinyint(1) after num_rated;
	alter table Articles alter display_extras set default '1';
	alter table Articles add published tinyint(1) NOT NULL after approved;
	alter table Articles alter published set default '0';
	alter table Articles add edited_on datetime default null after finished_on;
	alter table Articles add approved_on datetime default null after edited_on;

-- # multi-level groups
	alter table Agroups add parent int4 after id;
	alter table Agroups alter column parent set default '1';

	alter table Agroups add column inline int2 after description;
	alter table Agroups alter column inline set default '0';

	alter table Agroups add column intro text after description;

	alter table Agroups add column gorder int4 not null after parent;
	update Agroups set gorder='1';
--	alter table Agroups alter column gorder set not null;
	alter table Agroups alter column gorder set default '1';

	alter table Issues add column menu_title varchar(100) not null after name;
	update Issues set menu_title='' where menu_title is null;
--	alter table Issues alter column menu_title set not null;
	alter table Issues alter column menu_title set default '';

	alter table Articles drop igroup;

	alter table Agroups drop index IDX_Agroup_id;
	alter table Agroups drop index IDX_Agroup_name;
	alter table Agroups add unique IDX_Agroups_name_parent (name, parent);
--	create unique index IDX_Agroups on Agroups (name,parent);

-- do this after check there's no id='1' group {
	delete from Agroups where id='1';
	insert into Agroups (id, name, menu_text, description, exported, parent, gorder)
		values ('1','domains','','','0',NULL,'1');
-- }
	update Agroups set parent='1' where id<>'1';
	update Agroups set intro='' where intro is null;
	update Agroups set inline='0' where inline is null;

-- nav specials - modify ...
--update Agroups set parent='47' name like '* %';
	update Agroups set gorder='2';

-- # Users
	alter table Users add language varchar(10) not null after ugroup;
	update Users set language='en' where language is null;
	update Users set language='en' where language='';
--	alter table Users alter language set not null;
	alter table Users alter language set default 'en';
	
	alter table Users add show_help tinyint(1) not null after language;
	update Users set show_help='0' where show_help IS NULL;
--	alter table Users alter show_help set not null;
	alter table Users alter show_help set default '1';
	
	alter table Users add page_size int(4) not null after show_help;
	update Users set page_size='20' where page_size IS NULL;
	update Users set page_size='20' where page_size='';
--	alter table Users alter page_size set not null;
	alter table Users alter page_size set default '20';

-- # Ainsertion
--	drop sequence ainsertion_id_seq;
--	create sequence ainsertion_id_seq;
	alter table Ainsertion add id INT4 not null auto_increment first, add index (id);
--	update Ainsertion set id=nextval('ainsertion_id_seq') where id is null;
--	alter table Ainsertion alter id set not null;
--	alter table Ainsertion alter id set default nextval('ainsertion_id_seq');
	alter table Ainsertion drop primary key;
	alter table Ainsertion add primary key (id);
	alter table Ainsertion add aorder INT4 not null after agroup;
	alter table Ainsertion alter aorder set default '1';
	alter table Ainsertion drop index IDX_Ainsertion_article_agroup;
	alter table Ainsertion add unique IDX_Ainsertion_article (article, agroup, aorder);

-- # Iusage
--	drop sequence Iusage_id_seq;
--	create sequence Iusage_id_seq;
	alter table Iusage add article_id INT4 first;
	alter table Iusage alter article_id set default null;
	update Iusage set article_id=Iusage.id where tableid='1';
	alter table Iusage add agroup_id INT4 after article_id;
	alter table Iusage alter agroup_id set default null;
	update Iusage set agroup_id=Iusage.id where tableid='2';
	alter table Iusage add issue_id INT4 after article_id;
	alter table Iusage alter issue_id set default null;
	update Iusage set issue_id=Iusage.id where tableid='3';
	alter table Iusage add user_id INT4 after agroup_id;
	alter table Iusage alter user_id set default null;
	update Iusage set user_id=Iusage.id where tableid='4';

	alter table Iusage drop tableid;
	alter table Iusage drop id;
	alter table Iusage add id INT4 not null auto_increment first, add index (id);
--	update Iusage set id=nextval('Iusage_id_seq') where id is null;
--	alter table Iusage alter id set not null;
--	alter table Iusage alter id set default nextval('Iusage_id_seq');
	alter table Iusage drop primary key;
	alter table Iusage add primary key (id);
	alter table Iusage add unique (article_id, agroup_id, issue_id, user_id, image);
-- Indexes for table IUSAGE
--	create unique index isx_Iusage_id_Iusage_index on Iusage (id);
--	create unique index article_id_Iusage_index on Iusage (article_id,issue_id,agroup_id,user_id,image);

-- # Stats_unique
	alter table Stats_unique add nat_client varchar(255) after ip;
	alter table Stats_unique alter nat_client set default null;
	
	alter table Stats_unique add host varchar(255) after nat_client;
	alter table Stats_unique alter host set default null;

-- # Images
	alter table Images add href varchar(255) default null after owner;
	alter table Images add description text after href;

