--
--	update PostgreSQL artsys db: 0.3b -> 0.5b
--	Note: please take this just as a hint how to make the transformation,
--		make sure to dump the old contents before making any changes
--

	drop table ITables;
	update Articles set published_on=created_on where created_on is not null and published_on is null;

	alter table Articles add display_extras int2;
	alter table Articles alter display_extras set default '1';
	alter table Articles add published int2;
	update Articles set published='1' where (published_on is not null) or (issue is not null);
	update Articles set published='0' where published is null;
	alter table Articles alter published set NOT NULL;
	alter table Articles alter published set default '0';
	alter table Articles add edited_on timestamp;
	alter table Articles add approved_on timestamp;
	
-- # Images
	alter table Images add href varchar(255);
	alter table Images add description text;
	
-- # multi-level groups
	alter table agroups add column parent int4;
	alter table agroups alter column parent set default '1';

	alter table agroups add column inline int2;
	alter table agroups alter column inline set default '0';
	update agroups set inline='0';

	alter table agroups add column intro text;

	alter table agroups add column gorder int4;
	update agroups set gorder='1';
	alter table agroups alter column gorder set not null;
	alter table agroups alter column gorder set default '1';

	alter table issues add column menu_title varchar(100);
	update issues set menu_title='' where menu_title is null;
	alter table issues alter column menu_title set not null;
	alter table issues alter column menu_title set default '';

	alter table articles drop igroup;

	drop index idx_agroup_name_agroups_index;
	drop index name_agroups_index;
	create unique index name_agroups_index on agroups (name,parent);

-- insert top level group
	insert into agroups (name, menu_text, description, exported, parent, gorder) values ('domains','','','0',NULL,'1');
	update agroups set parent=(select max(id) from agroups) where id<>(select max(id) from agroups);
	update agroups set gorder='2';
	

-- # Users
	alter table users add language varchar(10);
	update users set language='en' where language is null;
	alter table users alter language set not null;
	alter table users alter language set default 'en';
	
	alter table users add show_help INT2;
	update users set show_help='0' where show_help IS NULL;
	alter table users alter show_help set not null;
	alter table users alter show_help set default '1';
	
	alter table users add page_size INT4;
	update users set page_size='20' where page_size IS NULL;
	alter table users alter page_size set not null;
	alter table users alter page_size set default '20';

-- # Ainsertion
	drop sequence ainsertion_id_seq;
	create sequence ainsertion_id_seq;
	alter table Ainsertion add id INT4;
--	alter table Ainsertion drop primary key;
	update Ainsertion set id=nextval('ainsertion_id_seq') where id is null;
	alter table Ainsertion alter id set not null;
	alter table Ainsertion alter id set default nextval('ainsertion_id_seq');
	alter table Ainsertion add aorder INT4;
	alter table Ainsertion alter aorder set default '1';
	update Ainsertion set aorder='1' where aorder is null;
	alter table Ainsertion alter aorder set not null;
	alter table Ainsertion add primary key (id);
	create unique index IDX_Ainsertion_article ON Ainsertion (article, agroup, aorder);


-- # Iusage
	drop sequence iusage_id_seq;
	create sequence iusage_id_seq;
	alter table Iusage add article_id INT4;
	update iusage set article_id=iusage.id where tableid='1';
	alter table Iusage add agroup_id INT4;
	update iusage set agroup_id=iusage.id where tableid='2';
	alter table Iusage add issue_id INT4;
	update iusage set issue_id=iusage.id where tableid='3';
	alter table Iusage add user_id INT4;
	update iusage set user_id=iusage.id where tableid='4';

	alter table Iusage drop tableid;
	alter table Iusage drop id;
	alter table Iusage add id INT4;
	update Iusage set id=nextval('iusage_id_seq') where id is null;
	alter table Iusage alter id set not null;
	alter table Iusage alter id set default nextval('iusage_id_seq');
	alter table iusage add primary key (id);
	alter table iusage add unique (article_id, agroup_id, issue_id, user_id, image);
-- Indexes for table IUSAGE
	create unique index isx_iusage_id_iusage_index on iusage (id);
	create unique index article_id_iusage_index on iusage (article_id,issue_id,agroup_id,user_id,image);

-- # Stats_unique
	alter table Stats_unique add nat_client varchar(255);
	alter table Stats_unique alter nat_client set default null;
	
	alter table Stats_unique add host varchar(255);
	alter table Stats_unique alter host set default null;

